<?php 





// +------------------------------------------------------------------+

// | IF INSTRUCTED TO EDIT THE $main_path_force VARIABLE, EDIT THE    |

// | VALUE BETWEEN THE SINGLE QUOTES ON THE FOLLOWING LINE.           |

// +------------------------------------------------------------------+



$main_path_force   = '';



$perms_level_files  = '777';

$perms_level_dirs   = '777';

$perms_level_config = '777';



// +------------------------------------------------------------------+

// | DO NOT EDIT BELOW THIS LINE.                                     |

// +------------------------------------------------------------------+



// +--

// | The following parameters are to be left alone.  We initially set

// | this script up to handle its own errors, run using the BackEnd

// | interface and to produce output (so we can use KHXC_Error).  Right

// | before this script prints displays, we turn output off and destroy

// | the KHXC_Display output buffer.

// +--



$interface = 'BackEnd';

$output    = 1;

$errhandle = 1;



// +--

// | Enter the importer script name if it has been changed.  We also

// | set the script up as a robot so cookies are not printed.

// +--



$importer_script = 'importer-ccp6-uk.php';

$importer_name   = 'ClickCartPro 6 UK';

$robot           = 'XCS Data Importer: ' . $importer_name;



// +--

// | Main program loader.  This object call creates an instance

// | of the KHXCmain class.  When the exec() function runs, the

// | program runs and produces output.  We exit() afterwards.

// +--



$khxcmain = new KHXCmain;



$khxcmain->exec(array('khxc.main_path_force'    => $main_path_force,

                      'khxc.interface'          => $interface,

                      'khxc.output'             => $output,

                      'khxc.errhandle'          => $errhandle,

                      'khxc.perms_level_files'  => $perms_level_files,

                      'khxc.perms_level_dirs'   => $perms_level_dirs,

                      'khxc.perms_level_config' => $perms_level_config,

                      'importer.script_name'    => $importer_script,

                      'importer.name'           => $importer_name,

                      'khxc.robot'              => $robot));



// +--

// | Exit() is called from within the KHXC during it's shutdown

// | function, however it's good practice to call it here as well

// | to handle garbage collection.

// +--



exit();



// +------------------------------------------------------------------+

// | Class Definition                                           [KHXC]|

// +------------------------------------------------------------------+



class KHXCmain {



// +--

// | This class is used to verify the PHP environment we're running

// | in, load and execute the KHXC class and provide error handling

// | outside of the scope of the main KHXC class.

// +--



// +------------------------------------------------------------------+

// | Class Variables                                            [KHXC]|

// +------------------------------------------------------------------+



var $class   = 'KHXCmain';

var $version = '6.6.0';

var $cerror;



// +------------------------------------------------------------------+

// | Constructor Function                                       [KHXC]|

// +------------------------------------------------------------------+



function KHXCmain () {



// +--

// | This is the constructor function.  This function starts up the

// | class.  Any pre-load variable assignments go here.

// +--



// +--

// | Return object.

// +--



return $this;



} // End of function.



// +------------------------------------------------------------------+

// | Function: exec                                             [KHXC]|

// +------------------------------------------------------------------+



function exec ($input = array()) {



// +--

// | This routine is run to run the internals of the class.  Main class

// | logic is contained in this function.

// +--



// +--

// | Globalize our input array.

// +--



if (!(empty($input))) {



     foreach ($input as $key => $value) {$this->globals($key,$value);}



} // End of if statement.



// +--

// | Set error handling up to output errors to the browser.  We handle

// | all errors except for E_NOTICE errors.

// +--



ini_set('display_errors','1');



error_reporting(E_ALL ^ E_NOTICE);



set_error_handler(array(&$this,'error_display'));



// +--

// | Determine the directory from where we're running this program.

// +--



$path = $this->globals('khxc.main_path_force');



if ((!(empty($path))) && (@file_exists($path))) {



     $path = $this->globals('khxc.main_path_force');



} elseif (@file_exists(dirname(__FILE__))) {



     $path = dirname(__FILE__);



} elseif (@file_exists(getcwd())) {



     $path = getcwd();



} elseif (@file_exists(dirname($_SERVER['PATH_TRANSLATED']))) {



     $path = dirname($_SERVER['PATH_TRANSLATED']);



} elseif (@file_exists(dirname($_SERVER['SCRIPT_FILENAME']))) {



     $path = dirname($_SERVER['SCRIPT_FILENAME']);



} else {



     $errstr = "



     <p>This script could not determine the directory from which it is 

     being executed.  You need to edit the scripts 'index.php', 'admin.php' 

     and 'installer.php' and enter a value for the \$main_path_force 

     variable at the top of those scripts. Follow the instructions in each of 

     those scripts for more information.</p>



     <p>If you have already edited the \$main_path_force variable and are 

     seeing this message again, the value you used for that variable 

     appears to be incorrect.  Please try again.</p>



     ";



     trigger_error($errstr,E_USER_ERROR);



} // End of if statement.



// +--

// | Format our working directory we've just determined and globalize it.

// +--



$path = $this->paths_convert($path);



$this->globals('khxc.main_path_force',$path);



// +--

// | Include our config.php in the public directory.  Globalize the 

// | config array.

// +--



if (@file_exists($this->globals('khxc.main_path_force') . '/config.php')) {



     include($this->globals('khxc.main_path_force') . '/config.php');



     foreach ($config as $key => $value) {$this->globals($key,$value);}



     unset($config);



} // End of if statement.



// +--

// | If the $config array key 'khxc.path_private' was not defined,

// | we had a problem and need to error out.

// +--



$pathpriv = $this->globals('khxc.path_private');



if (empty($pathpriv)) {



     $errstr = "



     <p>It appears you have not run the XCS

     installer script.  You need to run the installer script before

     accessing this script.</p>



     <p><a href=\"installer.php\" title=\"Installer\">Click here to run

     the installer script.</a></p>



     ";



     trigger_error($errstr,E_USER_ERROR);



} // End of if statement.



// +--

// | Our private config file will be included automatically

// | by the KHXC when it loads up.

// |

// | Now that we have our public config file included,

// | we can include our main KHXC file.

// +--



$privpath = $this->globals('khxc.path_private');



if (@file_exists($privpath . '/core/KHXC/KHXC.php')) {



     include_once($privpath . '/core/KHXC/KHXC.php');



// +--

// | If there is a problem finding the file, we error out.

// +--



} else {



     $errstr = "



     <p>This script could not locate the file 'KHXC.php' in the

     directory:</p>



     <p>{$privpath}/core/KHXC</p>



     <p>This could be the result of an incomplete installation.  The

     configuration files created by the installer appear to be complete, 

     however the installation of the codebase is incomplete.  This is a

     fatal error that cannot be resolved automatically.  Reinstall the

     software to continue.</p>



     <p><a href=\"installer.php\" title=\"Installer\">Click here to run

     the installer script.</a></p>



     ";



     trigger_error($errstr,E_USER_ERROR);



} // End of if statement.



// +--

// | If we were able to include our main KHXC file, we can run the KHXC.

// | Above we set 'output' to '0' and 'errhandle' to '1' so the KHXC will 

// | produce no output and not trigger errors internally.  There is no need 

// | to check for errors at this level.  

// |

// | Create the KHXC object.

// +--



global $xglobal_cache;



$khxc =& new KHXC($xglobal_cache);



if ($khxc->IsError($khxc->cerror)) {



     trigger_error($khxc->cerror->GetMessage(),E_USER_ERROR);



} // End of if statement.



// +--

// | Run the importer.  We pass it's constructor a reference to our

// | KHXC object.

// +--



$importer =& new KHXCimporter($khxc);



if ($khxc->IsError($importer->cerror)) {



     trigger_error($importer->cerror->GetMessage(),E_USER_ERROR);



} // End of if statement.



$importer->exec();



// +--

// | Run KHXC shutdown method.

// +--



$khxc->shutdown();



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: globals                                                |

// +------------------------------------------------------------------+



function globals ($name = '',$value = null,$default = null) {



// +--

// | This function maintains a global array of global variables for

// | use within the program.  Global variables can be set, changed and

// | obtained from this function.

// +--



global $xglobal_cache;



// +--

// | If the request contained a default identifier (passed as a true

// | value), we set a default value if the global doesn't exist.

// +--



if ((!(empty($name))) && (isset($value)) && (isset($default)) && (!(isset($xglobal_cache[$name])))) {



     $xglobal_cache[$name] = $value;



     return $value;



} // End of if statement.



// +--

// | Set requests have both a name and value passed

// | to this function.

// +--



if ((!(empty($name))) && (isset($value)) && (!(isset($default)))) {



     $xglobal_cache[$name] = $value;



     return $value;



} // End of if statement.



// +--

// | Get requests have only a global variable name

// | passed to this function.

// +--



if ((!(empty($name))) && (isset($xglobal_cache[$name]))) {



     return $xglobal_cache[$name];



} // End of if statement.



// +--

// | All other requests result in a null return value.

// +--



return null;



} // End of function.



// +------------------------------------------------------------------+

// | Function: paths_convert                                          |

// +------------------------------------------------------------------+



function paths_convert ($string) {



// +--

// | This function converts filesystem paths to unix-style and strips

// | any trailing slashes.

// +--



while (preg_match('/\\\\/',$string)) {$string = preg_replace('/\\\\/','/',$string);}



while (preg_match('/\/\//',$string)) {$string = preg_replace('/\/\//','/',$string);}



$string = preg_replace('/\/$/','',$string);



return $string;



} // End of function.



// +------------------------------------------------------------------+

// | Function: paths_strip                                            |

// +------------------------------------------------------------------+



function paths_strip ($string) {



// +--

// | This function strips full server paths from a given string for

// | security purposes.

// +--



$pathpub   = $this->globals('khxc.path_public');

$pathpriv  = $this->globals('khxc.path_private');

$pathforce = $this->globals('khxc.main_path_force');



$string = str_replace('\\','/',$string);



if (!(empty($pathforce))) {



     $find   = preg_quote($pathforce . '/','/');

     $string = preg_replace('/' . $find . '/','/',$string);



} // End of if statement.

 

if (!(empty($pathpub))) {



     $find   = preg_quote($pathpub . '/','/');

     $string = preg_replace('/' . $find . '/','/',$string);



} // End of if statement.



if (!(empty($pathpriv))) {



     $find   = preg_quote($pathpriv . '/','/');

     $string = preg_replace('/' . $find . '/','/',$string);



} // End of if statement.



return $string;



} // End of function.



// +------------------------------------------------------------------+

// | Function: error_display                                          |

// +------------------------------------------------------------------+



function error_display ($errno = '',$errstr = '',$errfile = '',$errline = '') {



// +--

// | This function is called via PHP when an error is encountered.

// | Scripts pass errors through this function via PHP's trigger_error

// | function using:

// |

// | trigger_error('some_error_message',E_USER_ERROR);

// | 

// | PHP also passes errors through this function without script

// | intervention.

// +--



// +--

// | If we've hit this function with a suppressed error or an E_STRICT

// | or E_NOTICE error, we return.

// +--



if ((error_reporting() == 0) || ($errno == E_NOTICE) || ($errno == E_STRICT)) {



     return 1;



} // End of if statement.



// +--

// | Modify our $errfile if it is non-blank.  We want to remove

// | full paths from error messages to increase security.

// +--



if ($errfile) {$errfile = $this->paths_strip($errfile);}



// +--

// | Modify our $errstr if it is non-blank.  We want to add <p>

// | tags if they're not there.

// +--



if (($errstr) && (!(preg_match('/<p>/',$errstr)))) {



     $errstr = '<p>' . $errstr . '</p>';



} // End of if statement.



// +--

// | Define our date (four digit year).

// +--



$date_year = @date('Y');



// +--

// | Print output header.

// +--



print $this->error_div_header();



// +--

// | Print output content.

// +--



if ($errstr) {print $this->error_div_content($errstr);}



// +--

// | Print output info.

// +--



if ($errno && $errline && $errfile) {print $this->error_div_info($errno,$errline,$errfile);}



// +--

// | Print output footer.

// +--



print $this->error_div_footer($date_year);



// +--

// | This was a fatal error so we exit.

// +--



exit();



} // End of function.



// +------------------------------------------------------------------+

// | Function: error_div_header                                       |

// +------------------------------------------------------------------+



function error_div_header () {



// +--

// | This function prints the error header.

// +--



$xhtml = <<<ENDOFTEXT



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">



<html xmlns="http://www.w3.org/1999/xhtml">



<head>



<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 



<style type="text/css" media="all">



body {

     font-family: Verdana, Tahoma, Arial, sans-serif;

     font-size: 11px;

     color: #333333;

     font-weight: normal;

     text-align: left;

     background-color: #F5F5F5;

     margin: 20px;

     }



a {

     color: #A83947;

     text-decoration: none;

     font-weight: normal;

     }



a.alt {

     color: #FFFFFF;

     font-weight: normal;

     }



a:hover {

     text-decoration: underline;

     }



p.inline {

     display: inline;

     }



.strong {

     font-weight: bold;

     }



label {

    color: #A83947;

}



#header {

     background-color: #FFFFFF;

     width: 610px;

     border: 1px solid #333333;

     padding: 5px;

     margin: 10px auto 0px auto;

     }



#content {

     color: #333333;

     background-color: #FFFFFF;

     border-left: 1px solid #333333;

     border-right: 1px solid #333333;

     border-bottom: 1px solid #333333;

     width: 600px;

     padding: 10px;

     margin: auto;

     }



#info {

     color: #333333;

     background-color: #A5C9EF;

     border-left: 1px solid #333333;

     border-right: 1px solid #333333;

     border-bottom: 1px solid #333333;

     width: 600px;

     padding: 10px;

     margin: auto;

     }



#footer {

     color: #FFFFFF;

     background-color: #A83947;

     border: 1px solid #333333;

     width: 600px;

     padding: 10px;

     margin: 10px auto 10px auto;

     }



#pgtitle {

     color: #A83947;

     padding: 0px;

     margin: 0px 0px 10px 0px;

     font-weight: bold;

     font-size: 18px;

     }



</style> 



<title>ClickCartPro Software: Script Execution Error</title>



</head>



<body>



<div id="header"><img src="media/khxc/clickcartpro_header.png" alt="ClickCartPro" width="400" height="98" /></div>



ENDOFTEXT;



return $xhtml;



} // End of function.



// +------------------------------------------------------------------+

// | Function: error_div_content                                      |

// +------------------------------------------------------------------+



function error_div_content ($errstr = '') {



// +--

// | This function prints the error contet.

// +--



$xhtml = <<<ENDOFTEXT



<div id="content">



<div id="pgtitle">Script Execution Error</div>



{$errstr}



</div>



ENDOFTEXT;



return $xhtml;



} // End of function.



// +------------------------------------------------------------------+

// | Function: error_div_info                                         |

// +------------------------------------------------------------------+



function error_div_info ($errno = '',$errline = '',$errfile = '') {



// +--

// | This function prints the error info.

// +--



$xhtml = <<<ENDOFTEXT



<div id="info">



<p class="inline">File: {$errfile} Line: {$errline} Error Number: {$errno}</p>



</div>



ENDOFTEXT;



return $xhtml;



} // End of function.



// +------------------------------------------------------------------+

// | Function: error_div_footer                                       |

// +------------------------------------------------------------------+



function error_div_footer ($date_year = '') {



// +--

// | This function prints the error footer.

// +--



$xhtml = <<<ENDOFTEXT



<div id="footer">



<p class="inline">&copy; 1999-{$date_year} GreenbarnWeb. The ClickCartPro software is copyrighted, trademarked, developed, 

distributed under license and supported by GreenbarnWeb (Greenbarn Consultants Ltd.).</p>



</div>



</body>



</html>



ENDOFTEXT;



return $xhtml;



} // End of function.



// +------------------------------------------------------------------+

// | End of Class                                               [KHXC]|

// +------------------------------------------------------------------+



} // End of class.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Importer Core Class                                              |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Class Definition: KHXCimporter                             [KHXC]|

// +------------------------------------------------------------------+



class KHXCimporter {



// +--

// | This class handles data imports into the KHXC  This script is to 

// | be considered standalone software and it's architecture and 

// | methodology are not indicative of the KHXC core codebase.  

// | Do not use code in this KHXCimporter class as a basis for KHXC

// | core or application code.

// +--



// +------------------------------------------------------------------+

// | Class Variables                                            [KHXC]|

// +------------------------------------------------------------------+



var $class   = 'KHXCimporter';

var $version = '1.0.0';

var $cerror;



var $dbrows_atonce = 100;



var $KHXC;

var $KHXC_Display;

var $KHXC_DB;

var $KHXC_DBX;

var $KHXC_Crypt;

var $KHXC_File;



// +------------------------------------------------------------------+

// | Constructor Function                                       [KHXC]|

// +------------------------------------------------------------------+



function KHXCimporter ($khxc_object = '') {



// +--

// | This is the constructor function.  This function starts up the

// | class.  Any pre-load variable assignments go here.

// +--



// +--

// | Define our KHXC object.

// +--



$this->KHXC =& $khxc_object;



// +--

// | Quick object load: KHXC_Display

// +--



$this->KHXC_Display =& $this->KHXC->quick_object('KHXC_Display','khxc');



if ($this->KHXC->IsError($this->KHXC_Display)) {$this->cerror = $this->KHXC_Display; return;}



// +--

// | Quick object load: KHXC_DB

// +--



$this->KHXC_DB =& $this->KHXC->quick_object('KHXC_DB','khxc','KHXC_DB_1');



if ($this->KHXC->IsError($this->KHXC_DB)) {$this->cerror = $this->KHXC_DB; return;}



// +--

// | Quick object load: KHXC_Crypt

// +--



$this->KHXC_Crypt =& $this->KHXC->quick_object('KHXC_Crypt','khxc');



if ($this->KHXC->IsError($this->KHXC_Crypt)) {$this->cerror = $this->KHXC_Crypt; return;}



// +--

// | Quick object load: KHXC_File

// +--



$this->KHXC_File =& $this->KHXC->quick_object('KHXC_File','khxc');



if ($this->KHXC->IsError($this->KHXC_File)) {$this->cerror = $this->KHXC_File; return;}



// +--

// | Return object.

// +--



return $this;



} // End of function.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Importer Wrapper                                                 |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Function: exec                                                   |

// +------------------------------------------------------------------+



function exec () {



// +--

// | This function runs the internals of the importer program.

// +--



// +--

// | Define some important variables.

// +--



$this->KHXC->globals('importer.numsteps','30');



// +--

// | Start buffering output.

// +--



if (!($this->KHXC->globals('importer.buffer_status'))) {



     @ob_start();



     $this->KHXC->globals('importer.buffer_status',1);



} // End of if statement.



// +--

// | Start processing.

// +--



$result = $this->exec_do();



if ($this->KHXC->IsError($result)) {



     trigger_error($result->GetMessage(),E_USER_ERROR);



} // End of if statement.



// +--

// | Finish buffering output.

// +--



if ($this->KHXC->globals('importer.buffer_status')) {



     $buffered_output = @ob_get_contents();



     @ob_end_clean();



     $this->KHXC->globals('importer.buffered_output',$buffered_output);



     $this->KHXC->globals('importer.buffer_status',0);



} // End of if statement.



// +--

// | Kill the buffering in the KHXC and set our display status to

// | false.

// +--



$this->KHXC_Display->buffer('CLEAN');



$this->KHXC->globals('khxc.output',0);



// +--

// | Print the display.

// +--



$this->disp();



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: exec_do                                                |

// +------------------------------------------------------------------+



function exec_do () {



// +--

// | This function processes the main logic of the importer.

// +--



// +--

// | Define the step we're on.

// +--



$step = $this->KHXC->globals('khxc_cgi.step');



if (!($step)) {$step = 'Intro';}



// +--

// | Get password info from form input and present the right 

// | interface.

// +--



$password = $this->KHXC->globals('khxc.password');



if (!(empty($password))) {



     $import_password = $this->KHXC->globals('khxc_cgi.import_password');



     if (!($import_password)) {



          $step = 'Password';



     } elseif (md5($import_password) != $password) {



          $message = "The password you entered is incorrect.  Please try again.";

          $step    = 'Password';



          $this->disp_message($message,'ERROR');



     } // End of if statement.



} elseif ($step != 'IntroP') {



     $step = 'Intro';



} // End of if statement.



// +--

// | Check the status of our license agreement acceptance.

// +--



$license_agree = $this->KHXC->globals('khxc_cgi.license_agree');



if (empty($license_agree)) {



          if ($step != 'Password' && $step != 'Intro') {



          $message = "You did not agree to the terms and conditions in the EULA.  

                      You must agree to these terms and conditions to continue.";



          if ($step == 'IntroP') {$step = 'Intro';}



          else {$step = 'Password';}



          $this->disp_message($message,'ERROR');



     } // End of if statement.



} // End of if statement.



// +--

// | Execute our step.

// +--



$result = $this->exec_step($step);



if ($this->KHXC->IsError($result)) {return $result;}



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: exec_step                                              |

// +------------------------------------------------------------------+



function exec_step ($step = 'Default') {



// +--

// | This function executes importer steps.

// +--



// +--

// | Use the step to figure out what we need to be doing.  If the

// | step is blank, we default to step I.  A list of the steps is

// | below:

// |

// | Step Number  Action          

// | -----------  -------------------

// | Default      Default Invalid Info Screen

// | Password     Password Collection

// | Location     Installation Location

// | LocationP    Installation Location - Process

// | Settings     Software Settings

// | SettingsP    Software Settings - Process

// | Media        Media Files

// | MediaP       Media Files - Process

// | CustAcct     Customer Accounts

// | CustAcctP    Customer Accounts - Processs

// | Affiliates   Affiliate Accounts 

// | AffiliatesP  Affiliate Accounts - Process

// | Maillist     Maillist Accounts

// | MaillistP    Maillist Accounts - Process

// | Category     Categories

// | CategoryP    Categories - Process

// | Product      Products

// | ProductP     Products - Process

// | ProdOpt      Product Options

// | ProdOptP     Product Options - Process

// | ProdOptSel   Product Options Selection

// | ProdOptSelP  Product Options Selection - Process

// | DynForm      Dynamic Forms

// | DynFormP     Dynamic Forms - Process       

// | DynFormFields      Dynamic Forms Fields

// | DynFormFieldsP     Dynamic Forms Fields - Process       

// | Orders       Orders

// | OrdersP      Orders - Process

// | OrderItems   OrderItems

// | OrderItemsP  OrderItems - Process

// | Discounts    Discount Codes

// | DiscountsP   Discount Codes - Process

// | HtmlPage     HTML Pages (User Defined)

// | HtmlPageP    HTML Pages (User Defined) - Process

// | Skin         Display Skin

// | SkinP        Display Skin - Process

// | Final        Final Confirm Display

// +--



switch ($step) {



     case "Password":

          $result = $this->step_Password();

          break;



     case "Location":

          $result = $this->step_Location();

          break;



     case "LocationP":

          $result = $this->step_LocationP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Location();

          }

          break;



     case "Settings":

          $result = $this->step_Settings();

          break;



     case "SettingsP":

          $result = $this->step_SettingsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Settings();

          }

          break;



     case "Media":

          $result = $this->step_Media();

          break;



     case "MediaP":

          $result = $this->step_MediaP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Media();

          }

          break;



     case "CustAcct":

          $result = $this->step_CustAcct();

          break;



     case "CustAcctP":

          $result = $this->step_CustAcctP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_CustAcct();

          }

          break;



     case "Affiliates":

          $result = $this->step_Affiliates();

          break;



     case "AffiliatesP":

          $result = $this->step_AffiliatesP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Affiliates();

          }

          break;



     case "Maillist":

          $result = $this->step_Maillist();

          break;



     case "MaillistP":

          $result = $this->step_MaillistP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Maillist();

          }

          break;



     case "Category":

          $result = $this->step_Category();

          break;



     case "CategoryP":

          $result = $this->step_CategoryP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Category();

          }

          break;



     case "Product":

          $result = $this->step_Product();

          break;



     case "ProductP":

          $result = $this->step_ProductP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Product();

          }

          break;



     case "ProdOpt":

          $result = $this->step_ProdOpt();

          break;



     case "ProdOptP":

          $result = $this->step_ProdOptP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_ProdOpt();

          }

          break;



     case "ProdOptSel":

          $result = $this->step_ProdOptSel();

          break;



     case "ProdOptSelP":

          $result = $this->step_ProdOptSelP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_ProdOpt();

          }

          break;



     case "DynForm":

          $result = $this->step_DynForm();

          break;



     case "DynFormP":

          $result = $this->step_DynFormP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_DynForm();

          }

          break;



     case "DynFormFields":

          $result = $this->step_DynFormFields();

          break;



     case "DynFormFieldsP":

          $result = $this->step_DynFormFieldsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_DynForm();

          }

          break;



     case "Orders":

          $result = $this->step_Orders();

          break;



     case "OrdersP":

          $result = $this->step_OrdersP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Orders();

          }

          break;



     case "OrderItems":

          $result = $this->step_OrderItems();

          break;



     case "OrderItemsP":

          $result = $this->step_OrderItemsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_OrderItems();

          }

          break;



     case "Discounts":

          $result = $this->step_Discounts();

          break;



     case "DiscountsP":

          $result = $this->step_DiscountsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Discounts();

          }

          break;



     case "Cart":

          $result = $this->step_Cart();

          break;



     case "CartP":

          $result = $this->step_CartP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Cart();

          }

          break;



     case "HtmlPage":

          $result = $this->step_HtmlPage();

          break;



     case "HtmlPageP":

          $result = $this->step_HtmlPageP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_HtmlPage();

          }

          break;



     case "CheckoutFields":

          $result = $this->step_CheckoutFields();

          break;



     case "CheckoutFieldsP":

          $result = $this->step_CheckoutFieldsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_CheckoutFields();

          }

          break;



     case "Femenus":

          $result = $this->step_Femenus();

          break;



     case "FemenusP":

          $result = $this->step_FemenusP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Femenus();

          }

          break;



     case "gateway":

          $result = $this->step_gateway();

          break;



     case "gatewayP":

          $result = $this->step_gatewayP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_gateway();

          }

          break;

     case "CustomMenu":

          $result = $this->step_CustomMenu();

          break;



     case "CustomMenuP":

          $result = $this->step_CustomMenuP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_CustomMenu();

          }

          break;

     case "recurorders":

          $result = $this->step_recurorders();

          break;



     case "recurordersP":

          $result = $this->step_recurordersP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_recurorders();

          }

          break;

     case "salecust":                    

          $result = $this->step_salecust();

          break;



     case "salecustP":

          $result = $this->step_salecustP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_salecust();

          }

          break;

     case "shipcust":                    

          $result = $this->step_shipcust();

          break;



     case "shipcustP":

          $result = $this->step_shipcustP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_shipcust();

          }

          break;

     case "shiprealtime":                    

          $result = $this->step_shiprealtime();

          break;



     case "shiprealtimeP":

          $result = $this->step_shiprealtimeP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_shiprealtime();

          }

          break;

     case "shiprealtime_p":                    

          $result = $this->step_shiprealtime_p();

          break;



     case "shiprealtime_pP":

          $result = $this->step_shiprealtime_pP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_shiprealtime_p();

          }

          break;

     case "shipuser":                    

          $result = $this->step_shipuser();

          break;



     case "shipuserP":

          $result = $this->step_shipuserP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_shipuser();

          }

          break;

     case "shipusersel":                    

          $result = $this->step_shipusersel();

          break;



     case "shipuserselP":

          $result = $this->step_shipuserselP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_shipusersel();

          }

          break;

     case "storemenu":                    

          $result = $this->step_storemenu();

          break;



     case "storemenuP":

          $result = $this->step_storemenuP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_storemenu();

          }

          break;

     case "sessions":                    

          $result = $this->step_sessions();

          break;



     case "sessionsP":

          $result = $this->step_sessionsP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_sessions();

          }

          break;



 

     case "Skin":

          $result = $this->step_Skin();

          break;





     case "SkinP":

          $result = $this->step_SkinP();

          if ($this->KHXC->IsError($result)) {

               $this->disp_message($result->GetMessage(),'ERROR');

               return $this->step_Skin();

          }

          break;



     case "Final":

          $result = $this->step_Final();

          break;



     default:

          $result = $this->step_Default();

          break;



} // End of switch statement.



// +--

// | Return the result.

// +--



return $result;



} // End of function.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Importer Steps                                                   |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Function: step_Default                                           |

// +------------------------------------------------------------------+



function step_Default () {



// +--

// | Importer Function Step.

// +--



// +--

// | Default Invalid Info Screen

// | 

// | This function prints a page indicating the importer was hit 

// | with invalid information and prints a valid importer link.

// +--



$insname = $this->KHXC->globals('importer.script_name');



print <<<ENDOFTEXT



<p>You have accessed this importer script using invalid data.  In 

order to use the importer script, please follow the link below:</p>



<p><a href="{$insname}" title="importer">Click here to run the importer script.</a></p>



ENDOFTEXT;



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Password                                          |

// +------------------------------------------------------------------+



function step_Password () {



// +--

// | Importer Function Step.

// +--



// +--

// | Password Collection

// | 

// | This function prints a form to be completed by the user to 

// | submit a password for this importer script.  This screen is 

// | accessed when a password already exists for the importer.

// +--



$software = $this->KHXC->globals('importer.name');



print <<<ENDOFTEXT



<p>This data importer script is designed to import data from a {$software} 

installation into the XCS database which this 

script is currenly associated with.</p>



<p><strong>Items that are imported by this script</strong>: 

Settings, media files, customer accounts, mail list accounts, affiliate accounts, 

categories, products, product options, product option select, dynamic forms, orders, discount codes, customer cart

and session info, shipping info, payment gateways,  

custom checkout fields, HTML pages (user defined) and the display skin.</p>







<p><strong>Please Note</strong>: If you have configured a Relational 

Database Management System (RDBMS) connection within your {$software} 

installation, that data source will be used for any tables you have exported 

to the RDBMS.  The access information needed to connect to that RDBMS will 

be automatically pulled from your {$software} installation.  There is no 

need to enter that information into this importer script.</p>



ENDOFTEXT;



// +--

// | Define the form.

// +--



$header = <<<ENDOFTEXT



<p>This importer script is protected by a password that was set up

during the initial installation of this program.  Enter the password 

you selected to protect the installer script below then click the 

'Continue' button at the bottom of this page to import data using this 

importer script.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_password';

$fields[0]['name']     = 'Installer Password';

$fields[0]['type']     = 'PASSWORD';

$fields[0]['required'] = '1';



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Enter the password below that you selected to permit controlled 

access to the XCS installer.  If you do not remember the installer password 

you selected during the initial installation of this program, edit the 

'config.php' file in this directory.  Delete the MD5 hash assigned to the 

'khxc.password' variable to create a new password.</p>



ENDOFTEXT;



$fields[1]['id']       = 'license_agree';

$fields[1]['name']     = 'License Agreement';

$fields[1]['type']     = 'CHECKBOX';

$fields[1]['required'] = '1';

$fields[1]['values']   = array('1' => 'I agree to the terms and conditions in the EULA.');



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Installation and use of this program requires you read and accept the 

End User License Agreement (EULA) distributed with this software.  Follow 

the link below to review the EULA.  The EULA is distributed in Adobe PDF 

format.  You will need Acrobat Reader, which is freely available from Adobe, 

to review the EULA.</p>



<p><a href="license.pdf" rel="external" title="License">Click here to review the EULA.</a></p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'Location'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Location                                          |

// +------------------------------------------------------------------+



function step_Location () {



// +--

// | Importer Function Step: 

// |

// | Installation Location & Destination Application

// +--



$this->KHXC->globals('importer.step','1');

$this->KHXC->globals('importer.steptext','Installation Location &amp; Destination Application');



// +--

// | Get a list of ecommerce applications we can import into.

// +--



$sql  = "SELECT id, name FROM khxc_apps WHERE id<>";

$sql .= $this->KHXC_DB->quote('khxc');



$result = $this->KHXC_DB->sql_do(array('sql'   => $sql,

                                       'table' => 'khxc_apps',

                                       'order' => array('id' => 'ASC')));



if ($this->KHXC->IsError($result)) {



     $message  = "An error was encountered while attempting to retrieve a 

                  list of installed applications.  The error returned was: ";



     $message .= $result->GetMessage();



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



if (empty($result)) {



     $message  = "This importer script was unable to retrieve information on 

                  any installed applications.  An application needs to be 

                  installed in order to use this importer.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



foreach ($result as $num => $row) {



     $apps_array[$row['id']] = $row['name'] . ' (' . $row['id'] . ')';



} // End of foreach statement.



// +--

// | Print the form.

// +--



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below the destination application for this data import and the server 

paths for the data and media directories for your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_destapp';

$fields[0]['name']     = 'Destination Application';

$fields[0]['type']     = 'SELECT';

$fields[0]['required'] = '1';

$fields[0]['values']   = $apps_array;



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Select the application into which you would like data imported.  The application you 

select should be an e-commerce application.</p>



ENDOFTEXT;



$fields[1]['id']       = 'import_dirmedia';

$fields[1]['name']     = 'Source Public Directory Path';

$fields[1]['type']     = 'TEXT-LONG';

$fields[1]['required'] = '1';



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Enter the absolute directory path to the public directory used by your 

{$software} installation.  If you do not know what your directory path 

is, you can locate it in your {$software} config.php file.  It 

is assigned in that file to the variable \$config['khxc.path_public'].</p>



<p>Example: /home/username/www/khxc or C:/Inetpub/wwwroot/khxc</p>



ENDOFTEXT;



$fields[2]['id']       = 'import_dirdata';

$fields[2]['name']     = 'Source Private Directory Path';

$fields[2]['type']     = 'TEXT-LONG';

$fields[2]['required'] = '1';



$fields[2]['desc']     = <<<ENDOFTEXT



<p>Enter the absolute directory path to the private directory used by your 

{$software} installation.  If you do not know what your directory path 

is, you can locate it in your {$software} config.php file.  It 

is assigned in that file to the variable \$config['khxc.path_private'].</p>



<p>Example: /home/username/khxc-private or C:/Inetpub/khxc-private</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'LocationP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_LocationP                                         |

// +------------------------------------------------------------------+



function step_LocationP () {



// +--

// | Importer Function Step: 

// |

// | Installation Location & Destination Application - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Strip off any trailing slashes and convert to Unix style

// | paths/filenames.

// +--



$import_dirdata  = $this->KHXC->paths_convert($fd['import_dirdata']);

$import_dirmedia = $this->KHXC->paths_convert($fd['import_dirmedia']);



$this->KHXC->globals('khxc_cgi.import_dirdata',$import_dirdata);

$this->KHXC->globals('khxc_cgi.import_dirmedia',$import_dirmedia);



// +--

// | Check the formdata submission items and append error messages as

// | we go.

// +--



$errorcount = 0;



$errmsg     = "The following errors were encountered while attempting 

               to process your request: ";



// +--

// | Check the data (Private) directory.

// +--



if (!(@file_exists($import_dirdata . '/apps'))) {



     $errorcount++;



     $errmsg .= " {$errorcount}. The directory path for the private directory used by your

                 software installation is incorrect.  The path specified does not 

                 appear to contain any software installation files.";



} // End of if statement.



// +--

// | Check the media (Public) directory.

// +--



if (!(@file_exists($import_dirmedia . '/relay'))) {



     $errorcount++;



     $errmsg .= " {$errorcount}. The directory path for the public directory used by your

                 software installation is incorrect.  The path specified does not 

                 appear to contain any software installation files.";



} // End of if statement.



// +--

// | Return errors if we have any at this point.

// +--



if ($errorcount) {



     $result = $this->KHXC->RaiseError($errmsg);



     return $result;



} // End of if statement.



// +--

// | Print a confirmation message.

// +--



$message = "Thank you. The destination application and your source directory paths 

            have been validated.  You can now continue through the import process.";



$this->disp_message($message,'CONFIRM');



// +--

// | Go to the next step.

// +--



return $this->step_Settings();



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Settings                                          |

// +------------------------------------------------------------------+



function step_Settings () {



// +--

// | Importer Function Step: 

// |

// | Software Settings Import

// +--



$this->KHXC->globals('importer.step','2');

$this->KHXC->globals('importer.steptext','Software Settings Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import settings from your {$software} 

installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Software Settings Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import settings from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the settings from your {$software} 

installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'SettingsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_SettingsP                                         |

// +------------------------------------------------------------------+



function step_SettingsP () {



// +--

// | Importer Function Step: 

// |

// | Software Settings Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing settings.  No 

                 settings have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Media();



} // End of if statement.



// +--

// | Load Export Database Connection.

// +--

$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {

     $message = "Cannot Connect to the CCP6 DataBase. ";

     $this->disp_message($message,'CONFIRM');

     $this->disp_message($tabledefs->GetMessage(),'ERROR');

     return $this->step_Settings();

}

// +--

// | Load data.

// +--

$data = '';

$data = $this->import_load_data('khxc_settings','0','ALL');

if ($this->KHXC->IsError($data)) {

     $message = "Cannot Connect to the CCP6 DataBase. ";

     $this->disp_message($message,'CONFIRM');

     $this->disp_message($data->GetMessage(),'ERROR');

     return $this->step_Settings();

}



if (!(empty($data))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Settings();

    }
    foreach ($data as $num => $row) {

            

        // +--

        // | Set up our table.

        // +--



        $app = $this->KHXC->globals('khxc_cgi.import_destapp');



        $table = 'khxc_settings';
        unset($row['section']);
        $data = $row;


        $update_clause = $this->KHXC_DBY->clause_update(array('table'      => $table,

                                                             'data'       => $data));



        if (!($this->KHXC->IsError($update_clause))) {



          $sql = $update_clause . " WHERE id=" . $this->KHXC_DBY->quote($row['id']);





          $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                                 'table' => $table));



        } // End of if statement.

    } // End of foreach statement.

    

    

}  // End of if statement.



// +--

// | Print a confirmation message.

// +--



$message = "Thank you. Settings have been imported.  You can now continue 

            through the import process.";



$this->disp_message($message,'CONFIRM');



// +--

// | Go to the next step.

// +--



return $this->step_Media();



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Media                                             |

// +------------------------------------------------------------------+



function step_Media () {



// +--

// | Importer Function Step: 

// |

// | Media File Import

// +--



$this->KHXC->globals('importer.step','3');

$this->KHXC->globals('importer.steptext','Media File Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import media files from your {$software} 

installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Media File Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import media files from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the media files from your {$software} 

installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'MediaP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_MediaP                                            |

// +------------------------------------------------------------------+



function step_MediaP () {



// +--

// | Importer Function Step: 

// |

// | Media File Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing media files.  No 

                 files have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_CustAcct();



} // End of if statement.



// +--

// | Handle importing the data.

// +--



$app         = $this->KHXC->globals('khxc_cgi.import_destapp');



$dirdlsrc    = $this->KHXC->globals('khxc_cgi.import_dirdata')  . '/downloads';

$dirimgs     = $this->KHXC->globals('khxc_cgi.import_dirmedia') . '/media/' . $app;

$destdlsrc   = $this->KHXC->globals('khxc.path_private') . '/downloads';

$destimgs    = $this->KHXC->globals('khxc.path_public') . '/media/' . $app;



$translation = array($dirdlsrc                 => $destdlsrc,

                     $dirimgs . '/cat'         => $destimgs . '/cat',

                     $dirimgs . '/prodsm'      => $destimgs . '/prodsm',

                     $dirimgs . '/prodlg'      => $destimgs . '/prodlg',

                     $dirimgs . '/prodxl'      => $destimgs . '/prodxl',

                     $dirimgs . '/html'        => $destimgs . '/html');



foreach ($translation as $source => $dest) {



     $files  = array();



     $handle = @opendir($source);



     if (!(empty($handle))) {



          while (false !== ($file = @readdir($handle))) {



               if (($file != 'dir.txt') && ($file != 'index.htm') && ($file != 'default.htm') && (is_file($source . '/' . $file))) {



                    if (!(file_exists($dest . '/' . $file))) {



                         $this->KHXC_File->copy(array('source' => $source . '/' . $file,

                                                      'dest'   => $dest . '/' . $file));



                    } // End of if statement.



               } // End of if statement.



          } // End of while statement.



     } // End of if statement.



} // End of foreach statement.



// +--

// | Print a confirmation message.

// +--



$message = "Thank you. Media files have been imported.  You can now continue 

            through the import process.";

$this->disp_message($message,'CONFIRM');



// +--

// | Go to the next step.

// +--



return $this->step_CustAcct();



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CustAcct                                          |

// +------------------------------------------------------------------+



function step_CustAcct () {



// +--

// | Importer Function Step: 

// |

// | Customer Account Import

// +--



$this->KHXC->globals('importer.step','4');

$this->KHXC->globals('importer.steptext','Customer Account Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import customer accounts from your {$software} 

installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Customer Account Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import customer accounts from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the customer accounts from your {$software} 

installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'CustAcctP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CustAcctP                                         |

// +------------------------------------------------------------------+



function step_CustAcctP () {



// +--

// | Importer Function Step: 

// |

// | Customer Account Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing customer accounts.  No 

                 accounts have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Affiliates();



} // End of if statement.



// +--

// | Load CCP6 Data Base.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('khxc_users');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'CustAcctP';

$mtinfo['currtask']   = 'Customer Account Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('khxc_users',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_CustAcct();

    }



     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => 'khxc_users',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' => 'khxc_users'));



          } // End of if statement.





     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Customer accounts have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Affiliates();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Affiliates                                        |

// +------------------------------------------------------------------+



function step_Affiliates () {



// +--

// | Importer Function Step: 

// |

// | Affiliate Account Import

// +--



$this->KHXC->globals('importer.step','5');

$this->KHXC->globals('importer.steptext','Affiliate Account Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import affiliate accounts from your {$software} 

installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Affiliate Account Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import affiliate accounts from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the affiliate accounts from your {$software} 

installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'AffiliatesP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_AffiliatesP                                       |

// +------------------------------------------------------------------+



function step_AffiliatesP () {



// +--

// | Importer Function Step: 

// |

// | Affiliate Account Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing affiliate accounts. 

                 No accounts have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_MailList();



} // End of if statement.



// +--

// | Load settings and table definitions.

// +--





$tabledefs = $this->import_load_tabledefs($settings);



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('khxc_affpay');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'AffiliatesP';

$mtinfo['currtask']   = 'Affiliate Account Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('khxc_affpay',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_MailList();

    }




     foreach ($data as $num => $row) {



           $insert = $row;





           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => 'khxc_affpay',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));





     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Affiliate accounts have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_MailList();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Maillist                                          |

// +------------------------------------------------------------------+



function step_Maillist () {



// +--

// | Importer Function Step: 

// |

// | Mail List Import

// +--



$this->KHXC->globals('importer.step','6');

$this->KHXC->globals('importer.steptext','Guest Mail List Subscriber Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import guest mail list subscribers from 

your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Mail List Subscriber Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Guest mail list subscribers from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the mail list subscribers from your {$software} 

installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'MaillistP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_MaillistP                                         |

// +------------------------------------------------------------------+



function step_MaillistP () {



// +--

// | Importer Function Step: 

// |

// | Mail List Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing mail list subscribers. 

                 No subscribers have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Category();



} // End of if statement.



// +--

// | Load settings and table definitions.

// +--





$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('khxc_guestsub');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'MaillistP';

$mtinfo['currtask']   = 'Mail List Subscriber Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('khxc_guestsub',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Maillist();

    }



     foreach ($data as $num => $row) {



           $insert = $row;





           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => 'khxc_guestsub',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Mail list subscribers have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Category();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Category                                          |

// +------------------------------------------------------------------+



function step_Category () {



// +--

// | Importer Function Step: 

// |

// | Online Store Category Import

// +--



$this->KHXC->globals('importer.step','7');

$this->KHXC->globals('importer.steptext','Online Store Category Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online store categories 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Store Category Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import online store categories from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online store categories from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;

$fields[1]['id']       = 'delete_do';

$fields[1]['name']     = 'Delete Current Store Category Import';

$fields[1]['type']     = 'RADIO';

$fields[1]['required'] = '1';

$fields[1]['values']   = array('0' => 'No.',

                               '1' => 'Yes.');



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to delete the current store categories on the new store before importing from your 

{$software} installation.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'CategoryP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CategoryP                                         |

// +------------------------------------------------------------------+



function step_CategoryP () {



// +--

// | Importer Function Step: 

// |

// | Online Store Category Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0,

                                  'delete_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing online store categories. 

                 No categories have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Product();



} // End of if statement.





// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs($settings);



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_cat');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'CategoryP';

$mtinfo['currtask']   = 'Online Store Category Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');




// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_cat',$offset,$count);
    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Product();

    }

// +--

// | Check if we need to delete the current category info

// +--



if ((!(empty($fd['delete_do']))) && ($offset == '0')) {

    $sql  = "DELETE FROM gbu0_cat";

    $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                           'table' => 'gbu0_cat'));



} // End of if statement.


if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {





     foreach ($data as $num => $row) {



          $insert = $row;





          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_cat',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_cat'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online store categories have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Product();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Product                                           |

// +------------------------------------------------------------------+



function step_Product () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Import

// +--



$this->KHXC->globals('importer.step','8');

$this->KHXC->globals('importer.steptext','Online Store Product Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online store products 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Store Product Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import online store products from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online store products from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;

$fields[1]['id']       = 'delete_do';

$fields[1]['name']     = 'Delete Current Store Products Import';

$fields[1]['type']     = 'RADIO';

$fields[1]['required'] = '1';

$fields[1]['values']   = array('0' => 'No.',

                               '1' => 'Yes.');



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to delete the current store products on the new store before importing from your 

{$software} installation.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'ProductP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_ProductP                                          |

// +------------------------------------------------------------------+



function step_ProductP () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0,

                                  'delete_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing online store products. 

                 No products have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_ProdOpt();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_prod');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'ProductP';

$mtinfo['currtask']   = 'Online Store Product Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');




// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_prod',$offset,$count);
    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Product();

    }
// +--

// | Check if we need to delete the current products info

// +--



if ((!(empty($fd['delete_do']))) && ($offset == '0')) {

    $sql  = "DELETE FROM gbu0_prod";

    $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                           'table' => 'gbu0_prod'));



} // End of if statement.



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {





     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_prod',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_prod'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online store products have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_ProdOpt();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_ProdOpt                                           |

// +------------------------------------------------------------------+



function step_ProdOpt () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Option Import

// +--



$this->KHXC->globals('importer.step','9');

$this->KHXC->globals('importer.steptext','Online Store Product Option Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online store product options 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Store Product Option Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import online store product options from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online store product options from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;

$fields[1]['id']       = 'delete_do';

$fields[1]['name']     = 'Delete Current Store Product options Import';

$fields[1]['type']     = 'RADIO';

$fields[1]['required'] = '1';

$fields[1]['values']   = array('0' => 'No.',

                               '1' => 'Yes.');



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to delete the current store product options on the new store before importing from your 

{$software} installation.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'ProdOptP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_ProdOptP                                          |

// +------------------------------------------------------------------+



function step_ProdOptP () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Option Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0,

                                  'delete_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing online store product options. 

                 No options have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_ProdOptSel();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_prodoptions');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'ProdOptP';

$mtinfo['currtask']   = 'Online Store Product Option Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');




// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_prodoptions',$offset,$count);
    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_ProdOpt();

    }

// +--

// | Check if we need to delete the current product options info

// +--



if ((!(empty($fd['delete_do']))) && ($offset == '0')) {

    $sql  = "DELETE FROM gbu0_prodoptions";

    $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                           'table' => 'gbu0_prodoptions'));



} // End of if statement.


if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {





     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_prodoptions',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_prodoptions'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online store product options have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_ProdOptSel();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_ProdOptSel                                        |

// +------------------------------------------------------------------+



function step_ProdOptSel () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Option Selection Import

// +--



$this->KHXC->globals('importer.step','10');

$this->KHXC->globals('importer.steptext','Online Store Product Selection Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online store product options 

Selection from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Store Product Option Selection Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import online store product options Selection from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online store product options Selection from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;

$fields[1]['id']       = 'delete_do';

$fields[1]['name']     = 'Delete Current Store Product Options SelectionImport';

$fields[1]['type']     = 'RADIO';

$fields[1]['required'] = '1';

$fields[1]['values']   = array('0' => 'No.',

                               '1' => 'Yes.');



$fields[1]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to delete the current store product options selection on the new store before importing from your 

{$software} installation.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'ProdOptSelP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_ProdOptSelP                                          |

// +------------------------------------------------------------------+



function step_ProdOptSelP () {



// +--

// | Importer Function Step: 

// |

// | Online Store Product Option Selection Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0,

                                  'delete_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing online store product options. 

                 No options have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_DynForm();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_prodoptionsel');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'ProdOptSelP';

$mtinfo['currtask']   = 'Online Store Product Selection Option Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');




// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_prodoptionsel',$offset,$count);
    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_ProdOptSel();

    }

// +--

// | Check if we need to delete the current product options info

// +--



if ((!(empty($fd['delete_do']))) && ($offset == '0')) {

    $sql  = "DELETE FROM gbu0_prodoptionsel";

    $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                           'table' => 'gbu0_prodoptionsel'));



} // End of if statement.


if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {





     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_prodoptionsel',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_prodoptionsel'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online store product options selection have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_DynForm();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_DynForm                                           |

// +------------------------------------------------------------------+



function step_DynForm () {



// +--

// | Importer Function Step: 

// |

// | Dynamic Form Import

// +--



$this->KHXC->globals('importer.step','11');

$this->KHXC->globals('importer.steptext','Dynamic Form Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import dynamic forms 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Dynamic Form Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Dynamic Forms from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the dynamic forms from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'DynFormP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_DynFormP                                          |

// +------------------------------------------------------------------+



function step_DynFormP () {



// +--

// | Importer Function Step: 

// |

// | Dynamic Form Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Dynamic Forms. 

                 No dynamic forms have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_DynFormFields();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}





$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_dynforms');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'DynFormP';

$mtinfo['currtask']   = 'Dynamic Form Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_dynforms',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_DynForm();

    }



     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_dynforms',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_dynforms'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Dynamic forms have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_DynFormFields();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_DynFormFields                                     |

// +------------------------------------------------------------------+



function step_DynFormFields () {



// +--

// | Importer Function Step: 

// |

// | Dynamic Form Import

// +--



$this->KHXC->globals('importer.step','12');

$this->KHXC->globals('importer.steptext','Dynamic Form Fields Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import dynamic forms 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Dynamic Form Fields Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Dynamic Fields Forms from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the dynamic forms fields from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'DynFormFieldsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_DynFormFieldsP                                    |

// +------------------------------------------------------------------+



function step_DynFormFieldsP () {



// +--

// | Importer Function Step: 

// |

// | Dynamic Form Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Dynamic Forms Fields. 

                 No dynamic forms fields have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Orders();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}





$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_dynformsfields');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'DynFormFieldsP';

$mtinfo['currtask']   = 'Dynamic Form Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_dynformsfields',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_DynFormFields();

    }




     foreach ($data as $num => $row) {



          $insert = $row;





          // +--

          // | Do the insert and don't worry about errors.  By doing an insert

          // | we don't overwrite any existing data.

          // +--



          $sql = $this->KHXC_DBY->clause_insert(array('table' => $app . '_dynformsfields',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {



               $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_dynformsfields'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Dynamic forms have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Orders();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Orders                                            |

// +------------------------------------------------------------------+



function step_Orders () {



// +--

// | Importer Function Step: 

// |

// | Online Orders Import

// +--



$this->KHXC->globals('importer.step','13');

$this->KHXC->globals('importer.steptext','Online Orders Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online orders 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Orders Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Online Orders from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online orders from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'OrdersP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_OrdersP                                           |

// +------------------------------------------------------------------+



function step_OrdersP () {



// +--

// | Importer Function Step: 

// |

// | Online Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Online Orders. 

                 No online orders have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_OrderItems();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_orders');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'OrdersP';

$mtinfo['currtask']   = 'Online Orders Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_orders',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Orders();

    }


     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_orders',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));





     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online orders have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_OrderItems();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_OrderItems                                        |

// +------------------------------------------------------------------+



function step_OrderItems () {



// +--

// | Importer Function Step: 

// |

// | Online Order Items Import

// +--



$this->KHXC->globals('importer.step','14');

$this->KHXC->globals('importer.steptext','Online Order Items Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import online order items 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Online Order Items Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Online Order Items from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the online order items from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'OrderItemsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_OrderItemsP                                       |

// +------------------------------------------------------------------+



function step_OrderItemsP () {



// +--

// | Importer Function Step: 

// |

// | Online Order Items Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Online Order Items. 

                 No online order items have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Discounts();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_orderitems');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'OrderItemsP';

$mtinfo['currtask']   = 'Online Order Items Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_orderitems',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_OrderItems();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_orderitems',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Online order items have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Discounts();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Discounts                                         |

// +------------------------------------------------------------------+



function step_Discounts () {



// +--

// | Importer Function Step: 

// |

// | Discount Code Import

// +--



$this->KHXC->globals('importer.step','15');

$this->KHXC->globals('importer.steptext','Discount Code Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import discount codes 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Discount Code Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Discount Codes from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the discount codes from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'DiscountsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_DiscountsP                                        |

// +------------------------------------------------------------------+



function step_DiscountsP () {



// +--

// | Importer Function Step: 

// |

// | Discount Code Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Discount Codes. 

                 No discount codes have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_HtmlPage();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_discounts');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'DiscountsP';

$mtinfo['currtask']   = 'Discount Code Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_discounts',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Discounts();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_discounts',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Discount codes have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_HtmlPage();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_HtmlPage                                          |

// +------------------------------------------------------------------+



function step_HtmlPage () {



// +--

// | Importer Function Step: 

// |

// | HTML Page Import

// +--



$this->KHXC->globals('importer.step','16');

$this->KHXC->globals('importer.steptext','HTML Page Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import HTML pages 

from your {$software} installation.  HTML pages imported are of the 

user-defined type.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'HTML Page Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import HTML Pages from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the HTML pages from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'HtmlPageP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_HtmlPageP                                         |

// +------------------------------------------------------------------+



function step_HtmlPageP () {



// +--

// | Importer Function Step: 

// |

// | HTML Page Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing HTML Pages. 

                 No HTML pages have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Cart();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_html');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'HtmlPageP';

$mtinfo['currtask']   = 'HTML Page Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_html',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_HtmlPage();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $insert['htmlview'] = 'A';

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_html',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. HTML pages have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Cart();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Cart                                              |

// +------------------------------------------------------------------+



function step_Cart () {



// +--

// | Importer Function Step: 

// |

// | HTML Page Import

// +--



$this->KHXC->globals('importer.step','17');

$this->KHXC->globals('importer.steptext','Shopping Cart Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import shopping cart 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Shopping Cart Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Shopping Cart from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Shopping Cart from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'CartP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CartP                                         |

// +------------------------------------------------------------------+



function step_CartP () {



// +--

// | Importer Function Step: 

// |

// | Shopping Cart Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing shopping cart. 

                 No shopping cart have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_CheckoutFields();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_cart');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'CartP';

$mtinfo['currtask']   = 'Shopping Cart Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_cart',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_CheckoutFields();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_cart',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. shopping cart have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_CheckoutFields();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_CheckoutFields                                    |

// +------------------------------------------------------------------+



function step_CheckoutFields () {



// +--

// | Importer Function Step: 

// |

// | Checkout Feilds Import

// +--



$this->KHXC->globals('importer.step','18');

$this->KHXC->globals('importer.steptext','Checkout Fields Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Checkout Fields 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Checkout Fields Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Checkout Fields from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Checkout Fields from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'CheckoutFieldsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CheckoutFieldsP                                         |

// +------------------------------------------------------------------+



function step_CheckoutFieldsP () {



// +--

// | Importer Function Step: 

// |

// | Checkout Fields Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Checkout Fields. 

                 No Checkout Fields have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_CustomMenu();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_cofields');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'CheckoutFieldsP';

$mtinfo['currtask']   = 'Checkout Fields Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_cofields',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_CheckoutFields();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_cofields',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Checkout Fields have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_CustomMenu();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CustomMenu                                        |

// +------------------------------------------------------------------+



function step_CustomMenu () {



// +--

// | Importer Function Step: 

// |

// | Custom Menu Import

// +--



$this->KHXC->globals('importer.step','19');

$this->KHXC->globals('importer.steptext','Custom Menu Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Custom Menu 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Custom Menu Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Custom Menu from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Custom Menu from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'CustomMenuP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_CustomMenuP                                       |

// +------------------------------------------------------------------+



function step_CustomMenuP () {



// +--

// | Importer Function Step: 

// |

// | Custom Menu Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Custom Menu. 

                 No Custom Menu have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Femenus();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_custommenu');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'CustomMenuP';

$mtinfo['currtask']   = 'Custom Menu Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_custommenu',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_CustomMenu();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_custommenu',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Custom Menu have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Femenus();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Femenus                                        |

// +------------------------------------------------------------------+



function step_Femenus () {



// +--

// | Importer Function Step: 

// |

// | Front End Menu Import

// +--



$this->KHXC->globals('importer.step','20');

$this->KHXC->globals('importer.steptext','Front End Menu Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Front End Menu 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Front End Menu Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Front End Menu from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Front End Menu from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'FemenusP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_FemenusP                                       |

// +------------------------------------------------------------------+



function step_FemenusP () {



// +--

// | Importer Function Step: 

// |

// | Custom Menu Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Front End Menu. 

                 No Front End Menu have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_gateway();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_femenus');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'FemenusP';

$mtinfo['currtask']   = 'Front End Menu Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_femenus',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Femenus();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_femenus',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Front End Menu have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_gateway();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_gateway                                           |

// +------------------------------------------------------------------+



function step_gateway () {



// +--

// | Importer Function Step: 

// |

// | Front End Menu Import

// +--



$this->KHXC->globals('importer.step','21');

$this->KHXC->globals('importer.steptext','Gateway Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import gateway 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Gateway Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Gateway from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Front End Menu from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'gatewayP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_gatewayP                                          |

// +------------------------------------------------------------------+



function step_gatewayP () {



// +--

// | Importer Function Step: 

// |

// | Gateway Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing gateway. 

                 No gateway have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_recurorders();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_gateway');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'gatewayP';

$mtinfo['currtask']   = 'Gateway Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_gateway',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_gateway();

    }




     foreach ($data as $num => $row) {



           $insert['id']        = $row['id'];

           $insert['active']    = $row['active'];

           $insert['dispname']  = $row['dispname'];

           $insert['disporder'] = $row['disporder'];

           $insert['transkey']  = $row['transkey'];

           $insert['userid']    = $row['userid'];

          $sql = $this->KHXC_DBY->clause_update(array('table' => $app . '_gateway',

                                                     'data'  => $insert));



          if (!($this->KHXC->IsError($sql))) {

          $sql = $sql . " WHERE id=" . $this->KHXC_DB->quote($row['id']);

               $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                            'table' =>  $app . '_gateway'));



          } // End of if statement.



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Front End Menu have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_recurorders();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_recurorders                                        |

// +------------------------------------------------------------------+



function step_recurorders () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import

// +--



$this->KHXC->globals('importer.step','22');

$this->KHXC->globals('importer.steptext','Recur Orders Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Recur Orders 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Recur Orders Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Recur Orders from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Recur Orders from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'recurordersP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_recurordersP                                       |

// +------------------------------------------------------------------+



function step_recurordersP () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Recur Orders. 

                 No Recur Orders have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_salecust();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_recurorders');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'recurordersP';

$mtinfo['currtask']   = 'Recur Orders Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_recurorders',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_recurorders();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_recurorders',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Recur Orders have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_salecust();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_salecust                                          |

// +------------------------------------------------------------------+



function step_salecust () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import

// +--



$this->KHXC->globals('importer.step','23');

$this->KHXC->globals('importer.steptext','Custom Sales Discount Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Custom Sales Discount 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Custom Sales Discount Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Custom Sales Discount from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Custom Sales Discount from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'salecustP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_salecustP                                       |

// +------------------------------------------------------------------+



function step_salecustP () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Custom Sales Discount. 

                 No Custom Sales Discount have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipcust();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_salecust');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'salecustP';

$mtinfo['currtask']   = 'Custom Sales Discount Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_salecust',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_salecust();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_salecust',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Custom Sales Discount have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipcust();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shipcust                                          |

// +------------------------------------------------------------------+



function step_shipcust () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import

// +--



$this->KHXC->globals('importer.step','24');

$this->KHXC->globals('importer.steptext','Custom Shipping Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Custom Shipping 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Custom Shipping Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Custom Shipping from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Custom Shipping from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'shipcustP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shipcustP                                         |

// +------------------------------------------------------------------+



function step_shipcustP () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Custom Shipping. 

                 No Custom Shipping have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shiprealtime();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_shipcust');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'shipcustP';

$mtinfo['currtask']   = 'Custom Shipping Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_shipcust',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_shipcust();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_shipcust',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Custom Shipping have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shiprealtime();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shiprealtime                                      |

// +------------------------------------------------------------------+



function step_shiprealtime () {



// +--

// | Importer Function Step: 

// |

// | Real Time Import

// +--



$this->KHXC->globals('importer.step','25');

$this->KHXC->globals('importer.steptext','Real Time Shipping Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Real Time Shipping 

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Real Time Shipping Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Real Time Shipping from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Real Time Shipping from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'shiprealtimeP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shiprealtimeP                                     |

// +------------------------------------------------------------------+



function step_shiprealtimeP () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Real Time Shipping. 

                 No Real Time Shipping have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shiprealtime_p();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_shiprealtime');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'shiprealtimeP';

$mtinfo['currtask']   = 'Real Time Shipping Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_shiprealtime',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {





     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DB->quote($insert['id']);



           $this->KHXC_DB->sql_save(array('table'  => $app . '_shiprealtime',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Real Time Shipping have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shiprealtime_p();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_shiprealtime_p                                    |

// +------------------------------------------------------------------+



function step_shiprealtime_p () {



// +--

// | Importer Function Step: 

// |

// | Real Time Shipping Serivce Import

// +--



$this->KHXC->globals('importer.step','25');

$this->KHXC->globals('importer.steptext','Real Time Shipping Serivce Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Real Time Shipping Serivce

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Real Time Shipping Serivce Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Real Time Shipping Serivce from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Real Time Shipping Serivce from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'shiprealtime_pP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shiprealtime_pP                                     |

// +------------------------------------------------------------------+



function step_shiprealtime_pP () {



// +--

// | Importer Function Step: 

// |

// | Recur Orders Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Real Time Shipping Serivce. 

                 No Real Time Shipping Serivce have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipuser();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_shiprealtimep');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'shiprealtime_pP';

$mtinfo['currtask']   = 'Real Time Shipping Serivce Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_shiprealtimep',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_shiprealtime_p();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_shiprealtimep',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Real Time Shipping Serivce have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipuser();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_shipuser                                          |

// +------------------------------------------------------------------+



function step_shipuser () {



// +--

// | Importer Function Step: 

// |

// | User Defined Shipping Serivce Import

// +--



$this->KHXC->globals('importer.step','26');

$this->KHXC->globals('importer.steptext','User Defined Shipping Serivce Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import User Defined Shipping Serivce

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'User Defined Shipping Serivce Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import User Defined Shipping Serivce from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the User Defined Shipping Serivce from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'shipuserP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shipuserP                                     |

// +------------------------------------------------------------------+



function step_shipuserP () {



// +--

// | Importer Function Step: 

// |

// | User Defined Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing User Defined Shipping Serivce. 

                 No User Defined Shipping Serivce have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipusersel();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_shipuser');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'shipuserP';

$mtinfo['currtask']   = 'User Defined Shipping Serivce Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_shipuser',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_shipuser();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_shipuser',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. User Defined Shipping Serivce have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_shipusersel();



} // End of if statement.



} // End of function.

// +------------------------------------------------------------------+

// | Function: step_shipusersel                                       |

// +------------------------------------------------------------------+



function step_shipusersel () {



// +--

// | Importer Function Step: 

// |

// | User Defined Shipping Serivce Import

// +--



$this->KHXC->globals('importer.step','27');

$this->KHXC->globals('importer.steptext','User Defined Shipping Serivce Selection Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import User Defined Shipping Serivce Selection

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'User Defined Shipping Serivce Selection Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import User Defined Shipping Serivce Selection from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the User Defined Shipping Serivce Selection from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'shipuserselP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_shipuserselP                                     |

// +------------------------------------------------------------------+



function step_shipuserselP () {



// +--

// | Importer Function Step: 

// |

// | User Defined Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing User Defined Shipping Serivce Selection. 

                 No User Defined Shipping Serivce Selection have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_storemenu();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_shipusersel');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'shipuserselP';

$mtinfo['currtask']   = 'User Defined Shipping Serivce Selection Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_shipusersel',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_shipusersel();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_shipusersel',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. User Defined Shipping Serivce Selection have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_storemenu();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_storemenu                                         |

// +------------------------------------------------------------------+



function step_storemenu () {



// +--

// | Importer Function Step: 

// |

// | Store Menu Import

// +--



$this->KHXC->globals('importer.step','28');

$this->KHXC->globals('importer.steptext','Store Menu Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Store Menu

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Store Menu Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Store Menu from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Store Menu from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'storemenuP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_storemenuP                                        |

// +------------------------------------------------------------------+



function step_storemenuP () {



// +--

// | Importer Function Step: 

// |

// | Store Menu Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Store Menu. 

                 No Store Menu have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_sessions();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('gbu0_storemenu');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'storemenuP';

$mtinfo['currtask']   = 'Store Menu Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('gbu0_storemenu',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_storemenu();

    }




     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => $app . '_storemenu',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Store Menu have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_sessions();



} // End of if statement.



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_sessions                                          |

// +------------------------------------------------------------------+



function step_sessions () {



// +--

// | Importer Function Step: 

// |

// | Store Menu Import

// +--



$this->KHXC->globals('importer.step','29');

$this->KHXC->globals('importer.steptext','Sessions Info Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import Store Menu

from your {$software} installation.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'Sessions Info Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import Sessions Info from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the Sessions Info from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'sessionsP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_sessionsP                                        |

// +------------------------------------------------------------------+



function step_sessionsP () {



// +--

// | Importer Function Step: 

// |

// | Store Menu Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing Sessions Info. 

                 No Sessions Info have been imported.  You can now continue through 

                 the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Skin();



} // End of if statement.



// +--

// | Define the destination application.

// +--



$app  = $this->KHXC->globals('khxc_cgi.import_destapp');



// +--

// | Load settings and table definitions.

// +--



$tabledefs = $this->import_load_tabledefs();



if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}



// +--

// | Handle multi-step operations.

// +--



$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}

$count       = $this->dbrows_atonce;

$rowcount    = $this->import_count_rows('khxc_sessions');

$endnum_calc = $offset + $this->dbrows_atonce;



if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}



$new_offset  = $offset + $this->dbrows_atonce;

$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);



if ($offset == 0)     {$ntaskcurr = 1;

} elseif ($completed) {$ntaskcurr = $ntaskcount;

} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}



$mtinfo = array();



$mtinfo['currstep']   = 'sessionsP';

$mtinfo['currtask']   = 'Sessions Info Import';



$mtinfo['offset']     = $new_offset;

$mtinfo['ntaskcount'] = $ntaskcount;

$mtinfo['ntaskcurr']  = $ntaskcurr;

$mtinfo['mtcomplete'] = $completed;



$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');



// +--

// | Load data.

// +--



$data = $this->import_load_data('khxc_sessions',$offset,$count);



if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {


    // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_sessions();

    }



     foreach ($data as $num => $row) {



           $insert = $row;

           $where = 'id=' . $this->KHXC_DBY->quote($insert['id']);



           $this->KHXC_DBY->sql_save(array('table'  => 'khxc_sessions',

                                          'where'  => $where,

                                          'data'   => $insert,

                                          'update' => '*'));



     } // End of foreach statement.



     // +--

     // | Present the multitask form.

     // +--



     return $this->do_multitask($mtinfo);



// +--

// | We're finished otherwise.

// +--



} else {



     $message = "Thank you. Sessions Info have been imported.  You can now continue 

                 through the import process.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Skin();



} // End of if statement.



} // End of function.





// +------------------------------------------------------------------+

// | Function: step_Skin                                              |

// +------------------------------------------------------------------+



function step_Skin () {



// +--

// | Importer Function Step: 

// |

// | HTML Site Layout (Skin) Import

// +--



$this->KHXC->globals('importer.step','30');

$this->KHXC->globals('importer.steptext','HTML Site Layout (Skin) Import');



// +--

// | Print the form.

// +--



$this->KHXC->globals('khxc_cgi.import_do','0');



$software = $this->KHXC->globals('importer.name');



$header = <<<ENDOFTEXT



<p>Indicate below whether you would like to import your HTML site layout 

(skin) from your {$software} installation.  </p>



<p><strong>Please Note</strong>: That you will have to manually change your CCP6 skin imported here to use all the new features of the XCS software.</p>



ENDOFTEXT;



$fields[0]['id']       = 'import_do';

$fields[0]['name']     = 'HTML Site Layout (Skin) Import';

$fields[0]['type']     = 'RADIO';

$fields[0]['required'] = '1';

$fields[0]['values']   = array('0' => 'Skip this step.',

                               '1' => 'Import the HTML Site Layout from ' . $software . '.');



$fields[0]['desc']     = <<<ENDOFTEXT



<p>Indcate whether you would like to import the HTML site layout from your 

{$software} installation.  You have the option to skip this step.</p>



ENDOFTEXT;



// +--

// | Print the form.

// +--



$this->disp_form(array('header' => $header,

                       'fields' => $fields,

                       'step'   => 'SkinP'));



// +--

// | Return true

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_SkinP                                             |

// +------------------------------------------------------------------+



function step_SkinP () {



// +--

// | Importer Function Step: 

// |

// | HTML Site Layout (Skin) Import - Process

// +--



// +--

// | Make sure all required fields were completed.

// +--



$fd = $this->formdata_array(array('import_destapp'     => 1,

                                  'import_dirdata'     => 1,

                                  'import_dirmedia'    => 1,

                                  'import_do'          => 0));



if ($this->KHXC->IsError($fd)) {return $fd;}



// +--

// | Go to the next step and print a confirm message if we're skipping

// | this step.

// +--



if (empty($fd['import_do'])) {



     $message = "Thank you. You selected to skip importing the HTML site layout. 

                 A new skin has not been created.";



     $this->disp_message($message,'CONFIRM');



     return $this->step_Final();



} // End of if statement.

// +--

// | Load Export Database Connection.

// +--

$tabledefs = $this->import_load_tabledefs();



// +--

// | Load data.

// +--

$data = '';

$data = $this->import_load_data('khxc_apps','0','ALL');

$message .= "khxc apps data:" . print_r($data,1);



if (!(empty($data))) {

     // +--
    // | Load Export Database Connection.
    // +--

    $tabledefs = $this->load_xcs_database();



    if ($this->KHXC->IsError($tabledefs)) {

         $message = "Cannot Connect to the XCS DataBase. ";

         $this->disp_message($message,'CONFIRM');

         $this->disp_message($tabledefs->GetMessage(),'ERROR');

         return $this->step_Skin();

    }


    foreach ($data as $num => $row) {

            

        // +--

        // | Set up our table.

        // +--



        $app = $this->KHXC->globals('khxc_cgi.import_destapp');

        if ($app == $row['id']) {



            $table = 'khxc_apps';

            $data['defaultskin'] = $row['defaultskin'];



            $update_clause = $this->KHXC_DBY->clause_update(array('table'      => $table,

                                                                 'data'       => $data));



            if (!($this->KHXC->IsError($update_clause))) {



              $sql = $update_clause . " WHERE id=" . $this->KHXC_DBY->quote($row['id']);





              $result = $this->KHXC_DBY->sql_do(array('sql'   => $sql,

                                                     'table' => $table));



            } // End of if statement.

        } // End of if statement. 

    } // End of foreach statement.

    

    

}  // End of if statement.



$dirimgs     = $this->KHXC->globals('khxc_cgi.import_dirmedia') . '/skins';

$destimgs    = $this->KHXC->globals('khxc.path_public') . '/skins';;





$handle = @opendir($dirimgs);

$message .= "Opendir Info:" . print_r($handle,1);

if (is_dir($dirimgs)) {

    if ($dh = opendir($dirimgs)) {

        while (($file = readdir($dh)) !== false) {

            $message .= "filename: $file : filetype: " . filetype($dirimgs . '/' . $file) . "\n";

            if (($file != 'KHXCMI4') && ($file != '.') && ($file != '..') && (is_dir($dirimgs . '/' . $file))) {

                $this->KHXC_File->copy_dir(array('source'     => $dirimgs,

                                                 'dest'       => $destimgs,

                                                 'skip_dirs'  => array(0 => 'install'),

                                                 'skip_files' => array()));



                

                

            }



        }

        closedir($dh);

    }

}

$this->disp_message($message,'CONFIRM');



return $this->step_Final();



// +--

// | Delete any skin named 'CCP5XIMPORT'.

// +--



$dest = $this->KHXC->globals('khxc.path_public') . '/skins/CCP5XIMPORT';



$this->KHXC_File->delete_dir($dest);



// +--

// | Copy the Ecom skin over to 'CCP5XIMPORT'.

// +--



$source = $this->KHXC->globals('khxc.path_public') . '/skins/Ecom';



$this->KHXC_File->copy_dir(array('source'     => $source,

                                 'dest'       => $dest,

                                 'replace'    => array('/Ecom/' => '/CCP5XIMPORT/'),

                                 'skip_dirs'  => array(0 => 'install'),

                                 'skip_files' => array()));





// +--

// | Print a confirmation message.

// +--



$message = "Thank you. ";



$this->disp_message($message,'CONFIRM');



// +--

// | Go to the next step.

// +--



return $this->step_Final();



} // End of function.



// +------------------------------------------------------------------+

// | Function: step_Final                                             |

// +------------------------------------------------------------------+



function step_Final () {



// +--

// | Importer Function Step.

// +--



// +--

// | Define variables for the confirm display.

// +--



$link     = $this->KHXC->globals('khxc.script_backend');



// +--

// | Final Confirm Display

// +--



print <<<ENDOFTEXT



<p>The data import process has completed.  The data you chose to import 

has been saved to the XCS database and the 

filesystem used by the XCS.</p>



<p><a href="{$link}" title="Management Interface">Click here to run 

the KHXC Management Interface.</a></p>



ENDOFTEXT;



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Importer Display                                                 |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Function: disp                                                   |

// +------------------------------------------------------------------+



function disp () {



// +--

// | This function displays the importer screen output.

// +--



// +--

// | Define our date for our copyright and our EOL.

// +--



$date_year = @date('Y');

$eol       = $this->KHXC->globals('khxc.eol');



$title_add = '';



if ($this->KHXC->globals('importer.steptext')) {



     $title_add = ' - ' . $this->KHXC->xhtml_translate($this->KHXC->globals('importer.steptext'),'ENCODE');



} // End of if statement.



// +--

// | Print the header section.

// +--



print <<<ENDOFTEXT



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">



<html xmlns="http://www.w3.org/1999/xhtml">



<head>



<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 



<style type="text/css" media="all">



body {

     font-family: Verdana, Tahoma, Arial, sans-serif;

     font-size: 11px;

     color: #333333;

     font-weight: normal;

     text-align: left;

     background-color: #F5F5F5;

     margin: 20px;

     }



a {

     color: #A83947;

     text-decoration: none;

     font-weight: normal;

     }



a.alt {

     color: #FFFFFF;

     font-weight: normal;

     }



a:hover {

     text-decoration: underline;

     }



p.inline {

     display: inline;

     }



.strong {

     font-weight: bold;

     }



label {

    color: #A83947;

}



#header {

     background-color: #FFFFFF;

     width: 610px;

     border: 1px solid #333333;

     padding: 5px;

     margin: 10px auto 0px auto;

     }



#content {

     color: #333333;

     background-color: #FFFFFF;

     border-left: 1px solid #333333;

     border-right: 1px solid #333333;

     border-bottom: 1px solid #333333;

     width: 600px;

     padding: 10px;

     margin: auto;

     }



#footer {

     color: #FFFFFF;

     background-color: #A83947;

     border: 1px solid #333333;

     width: 600px;

     padding: 10px;

     margin: 10px auto 10px auto;

     }



#pgtitle {

     color: #A83947;

     padding: 0px;

     margin: 0px 0px 10px 0px;

     font-weight: bold;

     font-size: 18px;

     }



#meter {

     width: auto;

     margin: auto;

     text-align: center;

     }



p.meter {

     color: #FFFFFF;

     background-color: #A83947;

     display: inline;

     font-weight: bold;

     padding: 3px;

     }



p.metercomp {

     color: #FFFFFF;

     background-color: #A83947;

     display: inline;

     font-weight: bold;

     padding: 3px;

     }



p.meterpend {

     color: #A83947;

     background-color: #A83947;

     display: inline;

     font-weight: bold;

     padding: 3px;

     }



.msgerror {

     color: #FF0000;

     font-weight: bold;

     }



.msgconf {

     color: #339933;

     font-weight: bold;

     }



.hidden {

     display: none;

     }



.khxc_formfield {

     background-color: #FFFFFF;

     border: 1px solid #8C867B;

     margin: 5px 5px 0px 2px;

     font-size: 11px;

     }



.khxc_formfield:hover {

     background-color: #F5F5F5;

     }



.formbutton {

     color: #FFFFFF;

     background-color: #30569D;

     border: 1px solid #333333;

     padding: 1px;

     margin-top: 10px;

     margin-left: 2px;

     font-weight: bold;

     width: 100px;

     font-size: 11px;

     }



.formbutton:hover {

     color: #333333;

     background-color: #EFEFEF;

     }



fieldset {

     border: 1px solid #8C867B;

     padding: 10px;

     margin-bottom: 10px;

     }



</style>



<title>ClickCartPro Software: Installer{$title_add}</title>



<script type="text/javascript">

<!--



var submitted = false;

function DisableSubmit(formname) {

if(submitted == true) { return; }

document.forms[formname].submit();

document.forms[formname].SUBMIT.value = 'Please Wait...';

document.forms[formname].SUBMIT.disabled = true;

submitted = true;

}



// -->

</script>



<script type="text/javascript">

<!--



function externalLinks() {

if (!document.getElementsByTagName) return;

var anchors = document.getElementsByTagName("a");

for (var i=0; i<anchors.length; i++) {

var anchor = anchors[i];

if (anchor.getAttribute("href") &&

anchor.getAttribute("rel") == "external")

anchor.target = "_blank";

}

}

window.onload = externalLinks;



// -->

</script>



</head>



ENDOFTEXT;



if ($this->KHXC->globals('importer.auto_submit')) {



     print '<body onload="document.forms[\'importer\'].submit()">' . $eol;



} else {



     print '<body>' . $eol;



} // End of if statement.



print <<<ENDOFTEXT



<div id="header"><img src="media/khxc/clickcartpro_header.png" alt="ClickCartPro" width="400" height="98" /></div>



<div id="content">



ENDOFTEXT;



// +--

// | Print the import type.

// +--



print '<p><strong>Data Importer</strong>: ' . $this->KHXC->xhtml_translate($this->KHXC->globals('importer.name'),'ENCODE');



// +--

// | Print the page header section.

// +--



$step     = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.step'),'ENCODE');

$steptext = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.steptext'),'ENCODE');

$numsteps = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.numsteps'),'ENCODE');



if (($step) && ($steptext)) {



     print '<br /><strong>Step ' . $step . ' of ';

     print $numsteps . '</strong>: ' . $steptext;



} // End of if statement.



print '</p>' . $eol . $eol;



// +--

// | Print our content.

// +--



$content = $this->KHXC->globals('importer.buffered_output');



print $content;



// +--

// | Print the page footer.

// +--



print <<<ENDOFTEXT



</div>



<div id="footer">



<p class="inline">&copy; 1999-{$date_year} GreenbarnWeb. The ClickCartPro software is copyrighted, 

trademarked, developed, distributed under license and supported by GreenbarnWeb (Greenbarn Consultants Ltd.).</p>



</div>



</body>



</html>



ENDOFTEXT;



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: disp_message                                           |

// +------------------------------------------------------------------+



function disp_message ($message = '',$type = 'ERROR') {



// +--

// | This function prints a message.

// +--



$eol = $this->KHXC->globals('khxc.eol');



// +--

// | If message is blank, return true without printing anything.

// +--



if ($message == '') {return 1;}



// +--

// | Replace full directory paths in the message.

// +--



$pathpriv_quoted = preg_quote($this->KHXC->globals('khxc.path_private'),'/');

$pathpub_quoted  = preg_quote($this->KHXC->globals('khxc.path_public'),'/');



$message = preg_replace('/' . $pathpriv_quoted . '\//','/',$message);

$message = preg_replace('/' . $pathpub_quoted  . '\//','/',$message);



// +--

// | Encode the message.

// +--



$message = $this->KHXC->xhtml_translate($message,'ENCODE');



// +--

// | Print the message.

// +--



if ($type == 'ERROR') {



     print '<p class="msgerror">' . $message . '</p>' . $eol . $eol;



} else {



     print '<p class="msgconf">' . $message . '</p>' . $eol . $eol;



} // End of if statement.



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: formdata_array                                         |

// +------------------------------------------------------------------+



function formdata_array ($input = array()) {



// +--

// | This function returns an array of formdata values.  It accepts

// | input in an array with the following format:

// |

// | key:   The formdata field.

// | value: Boolean indicating required status.

// |

// | This function will return an error object if any required fields

// | are not complete.

// +--



$result = array();



if (empty($input)) {return $result;}



$reqnotcomp = 0;



foreach ($input as $key => $value) {



     $xvalue = $this->KHXC->globals('khxc_cgi.' . $key);



     if (!(isset($xvalue))) {$xvalue = '';}



     $result[$key] = $xvalue;



     if ((empty($result[$key])) && (!(empty($value)))) {$reqnotcomp++;}



} // End of foreach statement.



if ($reqnotcomp) {



     $message = "You did not complete all of the required fields before 

                 clicking the 'Continue' button.  Please try again.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Return the result array.

// +--



return $result;



} // End of function.



// +------------------------------------------------------------------+

// | Function: disp_form                                              |

// +------------------------------------------------------------------+



function disp_form ($input = array()) {



// +--

// | This function prints an XHTML form to be used by the importer.

// | 

// | Input is accepted in the form of an array with the following

// | parameters:

// |

// | 'header'   => XHTML header

// |

// | 'step'     => The step to post to.

// |

// | 'supform'  => Optional boolean indicator.  If true the opening 

// |               <form> tag is supressed.  Useful if the header

// |               contains form fields.

// |

// | 'autosub'  => Optional indicator.  If value is 1 this form 

// |               will be auto-submitted.

// |

// | 'fields'   => An array of fields with the following array keys:

// |

// |               'id'       => Form field name.

// |

// |               'name'     => Field display name.

// |

// |               'type'     => Form field type (SELECT, RADIO, HIDDEN

// |                           CHECKBOX, TEXT-REG, TEXT-LONG, PASSWORD)

// |

// |               'desc'     => Pre-formatted XHTML description.

// |

// |               'values'   => An array of values (key = select value,

// |                             value = select display name) for a 

// |                             SELECT, CHECKBOX or RADIO field.

// |

// |               'value'    => A value to use for HIDDEN fields.

// |

// |               'required' => Boolean required indicator.

// +--



$eol = $this->KHXC->globals('khxc.eol');



// +--

// | Set up function variables.

// +--



$header  = (isset($input['header'])  ? $input['header']  : '');

$fields  = (isset($input['fields'])  ? $input['fields']  : array());

$step    = (isset($input['step'])    ? $input['step']    : 'Default');

$supform = (isset($input['supform']) ? $input['supform'] : 0);

$autosub = (isset($input['autosub']) ? $input['autosub'] : 0);



// +--

// | Handle the auto-submit form object.

// +--



if ($autosub == 1) {



     $this->KHXC->globals('importer.auto_submit',1);



} // End of if statement.



// +--

// | Print the form header.

// +--



if ($header) {



     print $header . $eol . $eol;



} // End of if statement.



// +--

// | Print the <form> element and required info if not supressed.

// +--



if (empty($supform)) {



     $insname = $this->KHXC->globals('importer.script_name');



     print '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;



     print '<p>All required fields are marked with a star (*). ';



     if ($autosub == 1) {



          print 'This form should auto-submit itself.  If this does not occur, ';

          print 'click the \'Continue\' button at the bottom of ';

          print 'this page to proceed.</p>' . $eol . $eol;





     } else {



          print 'Click the \'Continue\' button at the bottom of ';

          print 'this page to proceed.</p>' . $eol . $eol;



     } // End of if statement.



} // End of if statement.



// +--

// | Get a list of all of the fields.

// +--



$seen = array();



foreach ($fields as $num => $field) {



     $id = (isset($field['id']) ? $field['id'] : '');



     $seen[$id] = 1;



} // End of foreach statement.



// +--

// | Print the HIDDEN form fields.

// +--



foreach ($fields as $num => $field) {



     $id       = (isset($field['id'])       ? $field['id']       : '');

     $name     = (isset($field['name'])     ? $field['name']     : '');

     $type     = (isset($field['type'])     ? $field['type']     : '');

     $desc     = (isset($field['desc'])     ? $field['desc']     : '');

     $values   = (isset($field['values'])   ? $field['values']   : array());

     $value    = (isset($field['value'])    ? $field['value']    : '');

     $required = (isset($field['required']) ? $field['required'] : '');



     if ($type == 'HIDDEN') {



          $pid    = $this->KHXC->xhtml_translate($id,'ENCODE');

          $pvalue = $this->KHXC->xhtml_translate($value,'ENCODE');



          print '<p class="hidden"><input type="hidden" name="' . $pid . '" ';

          print 'id="' . $pid . '" value="' . $pvalue . '" /></p>' . $eol . $eol;



     } // End of if statement.



} // End of foreach statement.



// +--

// | Print the ALL OTHER form fields.

// +--



foreach ($fields as $num => $field) {



     $id       = (isset($field['id'])       ? $field['id']       : '');

     $name     = (isset($field['name'])     ? $field['name']     : '');

     $type     = (isset($field['type'])     ? $field['type']     : '');

     $desc     = (isset($field['desc'])     ? $field['desc']     : '');

     $values   = (isset($field['values'])   ? $field['values']   : array());

     $value    = (isset($field['value'])    ? $field['value']    : '');

     $required = (isset($field['required']) ? $field['required'] : '');



     $req = ''; if ($required) {$req = '*';}



     $pvalue = $this->KHXC->globals('khxc_cgi.' . $id); if (empty($pvalue)) {$pvalue = '';}



     $pid    = $this->KHXC->xhtml_translate($id,'ENCODE');

     $pname  = $this->KHXC->xhtml_translate($name,'ENCODE');



     $xpid   = $pid;



     if (($type == 'CHECKBOX') || ($xpid == 'RADIO')) {$xpid .= '--1';}



     if ($type != 'HIDDEN') {



          print '<fieldset>' . $eol . $eol;



          print '<legend class="strong"><label for="' . $xpid . '">' . $pname . $req;

          print '</label></legend>' . $eol . $eol;



          print $desc . $eol . $eol;



          if (($type == 'TEXT-REG') || ($type == 'TEXT-LONG') || ($type == 'PASSWORD')) {



               $pvalue = $this->KHXC->xhtml_translate($pvalue,'ENCODE');



               $size  = '25';   if ($type == 'TEXT-LONG')  {$size = '50';}

               $xtype = 'text'; if ($type == 'PASSWORD')   {$xtype = 'password';}



               print '<input class="formfield" type="' . $xtype . '" name="';

               print $pid . '" id="' . $pid . '" value="';

               print $pvalue . '" size="' . $size . '" />' . $eol . $eol;



          } else {



               if (is_array($pvalue)) {$pvalue = array_flip($pvalue);} else {$pvalue = array($pvalue => 1);}



               if (!(empty($values))) {



                    $count   = 0;

                    $pvalues = array();



                    $made_checked = 0;



                    foreach ($values as $xkey => $xvalue) {



                         $count++;



                         $checked = 0; if (array_key_exists($xkey,$pvalue)) {$checked = 1; $made_checked = 1;}



                         $pvalues[] = array('value'   => $xkey,

                                            'display' => $this->KHXC->xhtml_translate($xvalue,'ENCODE'),

                                            'checked' => $checked,

                                            'xid'     => $id . '--' . $count);



                    } // End of foreach statement.



                    if ((!($made_checked)) && ($type == 'RADIO')) {$pvalues[0]['checked'] = 1;}



                    if ($type == 'SELECT') {



                          print '<select class="formfield" name="' . $pid . '" id="' . $pid . '">' . $eol;



                          foreach ($pvalues as $num => $xv) {



                               $checked = ''; if ($xv['checked']) {$checked = ' selected="selected"';}



                               print '<option value="' . $xv['value'] . '" ';

                               print $checked . '>' . $xv['display'] . '</option>' . $eol;



                          } // End of foreach statement.



                          print '</select>' . $eol . $eol;



                    } elseif ($type == 'CHECKBOX') {



                          foreach ($pvalues as $num => $xv) {



                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}



                               print '<p><input type="checkbox" name="' . $pid . '[]" ';

                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';

                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;



                          } // End of foreach statement.



                    } elseif ($type == 'RADIO') {



                          foreach ($pvalues as $num => $xv) {



                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}



                               print '<p><input type="radio" name="' . $pid . '" ';

                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';

                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;



                          } // End of foreach statement.



                    } // End of if statement.



               } // End of if statement.



          } // End of if statement.



          print '</fieldset>' . $eol . $eol;



     } // End of if statement.



} // End of foreach statement.



// +--

// | Print our license_agree, import_password and step fields

// | as well as other fields specific to this importer - if 

// | they weren't seen.

// +--



if (!(array_key_exists('license_agree',$seen))) {



     $value = $this->KHXC->globals('khxc_cgi.license_agree');



     if (is_array($value)) {$value = 1;}



     $value = $this->KHXC->xhtml_translate($value,'ENCODE');



     print '<p class="hidden"><input type="hidden" name="license_agree" ';

     print 'id="license_agree" value="' . $value . '" /></p>' . $eol . $eol;



} // End of if statement.



if (!(array_key_exists('import_password',$seen))) {



     $value = $this->KHXC->xhtml_translate($this->KHXC->globals('khxc_cgi.import_password'),'ENCODE');



     print '<p class="hidden"><input type="hidden" name="import_password" ';

     print 'id="import_password" value="' . $value . '" /></p>' . $eol . $eol;



} // End of if statement.



if (!(array_key_exists('step',$seen))) {



     print '<p class="hidden"><input type="hidden" name="step" ';

     print 'id="step" value="' . $step . '" /></p>' . $eol . $eol;



} // End of if statement.



if (($autosub == 1) && (!(array_key_exists('auto_submit',$seen)))) {



     print '<p class="hidden"><input type="hidden" name="auto_submit" ';

     print 'id="auto_submit" value="1" /></p>' . $eol . $eol;



} // End of if statement.



if (!(array_key_exists('import_destapp',$seen))) {



     $import_destapp = $this->KHXC->globals('khxc_cgi.import_destapp');

     if (empty($import_destapp)) {$import_destapp = '';}



     print '<p class="hidden"><input type="hidden" name="import_destapp" ';

     print 'id="import_destapp" value="' . $import_destapp . '" /></p>' . $eol . $eol;



} // End of if statement.



if (!(array_key_exists('import_dirdata',$seen))) {



     $import_dirdata = $this->KHXC->globals('khxc_cgi.import_dirdata');

     if (empty($import_dirdata)) {$import_dirdata = '';}



     print '<p class="hidden"><input type="hidden" name="import_dirdata" ';

     print 'id="import_dirdata" value="' . $import_dirdata . '" /></p>' . $eol . $eol;



} // End of if statement.



if (!(array_key_exists('import_dirmedia',$seen))) {



     $import_dirmedia = $this->KHXC->globals('khxc_cgi.import_dirmedia');

     if (empty($import_dirmedia)) {$import_dirmedia = '';}



     print '<p class="hidden"><input type="hidden" name="import_dirmedia" ';

     print 'id="import_dirmedia" value="' . $import_dirmedia . '" /></p>' . $eol . $eol;



} // End of if statement.



// +--

// | Print the form footer.

// +--



print <<<ENDOFTEXT



<p><input class="formbutton" type="submit" name="SUBMIT" id="SUBMIT" value="Continue" onclick="return DisableSubmit('importer');" /></p>



</form>



ENDOFTEXT;



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Multi-Task Form Display                                          |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Function: do_multitask                                           |

// +------------------------------------------------------------------+



function do_multitask ($multitask = array()) {



// +--

// | This function presents a multi-task form.

// +--



$eol = $this->KHXC->globals('khxc.eol');



// +--

// | Define our current task.

// +--



$current_task_text = $this->KHXC->xhtml_translate($multitask['currtask'],'ENCODE');



// +--

// | Set up the progress bar.

// +--



$progress_bar = '';



$progress_bar_countt  = $multitask['ntaskcount'];

$progress_bar_counti  = $multitask['ntaskcurr'];

$progress_bar_disp    = 50;



$bars_disp= '';

$bars_leftdisp = '';

$bar_count= 0;



$pct = $progress_bar_counti / $progress_bar_countt;

$pct = round($pct,2);



$pct_disp = $pct * 100;



$bars = $progress_bar_disp * $pct;

$bars = round($bars);



while ($bar_count < $bars) {$bar_count++; $bars_disp .= '|';}



$bars_left = $progress_bar_disp - $bars;



$bar_count = 0;



while ($bar_count < $bars_left) {$bar_count++; $bars_leftdisp .= '|';}



$pct_leftdisp = 100 - $pct_disp;



$progress_bar  = '<p class="meter">Progress: </p>';



if ($bars) {$progress_bar .= '<p class="metercomp">' . $bars_disp . '</p>';}



if ($bars_left) {$progress_bar .= '<p class="meterpend">' . $bars_leftdisp . '</p>';}



$progress_bar .= '<p class="meter"> [' . $pct_disp . '%]</p>' . $eol . $eol;



$header = <<<ENDOFTEXT



<p>You have selected to process a multi-task operation.  If this page does 

not automatically refresh itself within one second, click the 'Continue' 

button to proceed.</p>



ENDOFTEXT;



$insname = $this->KHXC->globals('importer.script_name');



$header .= '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;



$header .= <<<ENDOFTEXT



<fieldset>



<legend class="strong"><label for="taskdo">Task Status</label></legend>



<p>The progress meter below displays your progress during this multi-task operation.</p>



<div id='meter'>{$progress_bar}</div>



<p class="hidden"><input type="hidden" name="taskstatus" id="taskstatus" value="1" /></p>



</fieldset>



<fieldset>



<legend class="strong"><label for="currenttask">Current Task</label></legend>



<p>{$current_task_text}</p>



<p class="hidden"><input type="hidden" name="currenttask" id="currenttask" value="1" /></p>



</fieldset>



ENDOFTEXT;



// +--

// | Formulate the form fields.

// +--



$fields[0]['id']       = 'offset';

$fields[0]['type']     = 'HIDDEN';

$fields[0]['required'] = 0;

$fields[0]['value']    = $multitask['offset'];



$fields[1]['id']       = 'import_do';

$fields[1]['type']     = 'HIDDEN';

$fields[1]['required'] = 0;

$fields[1]['value']    = 1;



if (!(empty($multitask['mtcomplete']))) {



     $fields[2]['id']       = 'mtcomplete';

     $fields[2]['type']     = 'HIDDEN';

     $fields[2]['required'] = 0;

     $fields[2]['value']    = 1;



} // End of if statement.



// +--

// | Print the form.

// +--



$this->disp_form(array('header'   => $header,

                       'fields'   => $fields,

                       'step'     => $multitask['currstep'],

                       'supform'  => 1,

                       'autosub'  => 1));



// +--

// | Return true.

// +--



return 1;



} // End of function.



// +------------------------------------------------------------------+

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// |                                                                  |

// | Importer Common Functions                                        |

// |                                                                  |

// |------------------------------------------------------------------|

// |------------------------------------------------------------------|

// +------------------------------------------------------------------+



// +------------------------------------------------------------------+

// | Function: import_load_settings                                   |

// +------------------------------------------------------------------+



function import_load_settings ($filename = 'settings.csv') {



// +--

// | This function loads settings from the source install.

// +--



// +--

// | Load settings from the CSV file.

// +--



$settings_file = $this->KHXC->globals('khxc_cgi.import_dirdata') . '/tables/' . $filename;



$settings = $this->KHXC_File->parsecsv(array('filename' => $settings_file));



// +--

// | Handle errors.

// +--



if ($this->KHXC->IsError($settings)) {



     $message  = "An error was encountered while attempting to retrieve  

                  settings from the source installation.  The error 

                  returned was: ";



     $message .= $settings->GetMessage();



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



if (empty($settings['data'])) {



     $message  = "An error was encountered while attempting to retrieve  

                  settings from the source installation.  No Settings were 

                  found.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Formulate our return array.

// +--



$colprefix = preg_replace('/\.csv$/','',$filename);



$settings_return = array();



foreach ($settings['data'] as $num => $row) {



     $settings_return[$row[$colprefix . '_id']] = $row[$colprefix . '_value'];



} // End of foreach statement.



// +--

// | Return the settings.

// +--



return $settings_return;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_load_tabledefs                                  |

// +------------------------------------------------------------------+



function import_load_tabledefs () {



// +--

// | This function loads table definitions.  It creates an array

// | with table names as keys and the data source as values.

// +--

// +--

// | Include our config.php in the public directory.  Globalize the 

// | config array.

// +--

if (@file_exists($this->KHXC->globals('khxc_cgi.import_dirdata') . '/config.php')) {



     include($this->KHXC->globals('khxc_cgi.import_dirdata') . '/config.php');

     $dsn = array('dbtype'   => $config['khxc.db_dbtype'],

                  'username' => $config['khxc.db_username'],

                  'password' => $config['khxc.db_password'],

                  'hostname' => $config['khxc.db_hostname'],

                  'dbname'   => $config['khxc.db_dbname']);



    if (empty($config)) {

      $message  = "Can not find the CCP6 private config file contents.";





      $result = $this->KHXC->RaiseError($message);



      return $result;

        

    }

     unset($config);

} else {

  $message  = "Can not find the CCP6 private config file.";





  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.





// +--

// | Attempt to load KHXC_DB using an alternate handle.

// +--



$this->KHXC_DBX =& $this->KHXC->load_object(array('app'       => 'khxc',

                                               'class'     => 'KHXC_DB',

                                               'name'      => 'KHXC_DB_2',

                                               'construct' => $dsn));



// +--

// | Handle constructor errors.

// +--



if ($this->KHXC->IsError($this->KHXC_DBX)) {



  $message  = "An error was encountered while attempting to create a new

               database object to connect to the RDBMS specified in the 

               source installation.  The error returned was: ";



  $message .= $this->KHXC_DBX->GetMessage();



  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.



// +--

// | Connect and handle errors.

// +--



$result = $this->KHXC_DBX->connect();



if ($this->KHXC->IsError($result)) {



  $message  = "An error was encountered while attempting to connect to 

               the RDBMS specified in the source installation.  The 

               error returned was: ";



  $message .= $result->GetMessage();



  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.







// +--

// | Return.

// +--



  return 1;



} // End of function.

// +------------------------------------------------------------------+

// | Function: load_xcs_database                                  |

// +------------------------------------------------------------------+



function load_xcs_database () {



// +--

// | This function loads table definitions.  It creates an array

// | with table names as keys and the data source as values.

// +--

// +--

// | Include our config.php in the public directory.  Globalize the 

// | config array.

// +--

if (@file_exists('config.php')) {



     include('config.php');
     print 'Found Public config';
     if (@file_exists( $config['khxc.path_private'] . '/config.php')) {
     include($config['khxc.path_private'] . '/config.php');     
     print 'Found private config';
     $dsn = array('dbtype'   => $config['khxc.db_dbtype'],

                  'username' => $config['khxc.db_username'],

                  'password' => $config['khxc.db_password'],

                  'hostname' => $config['khxc.db_hostname'],

                  'dbname'   => $config['khxc.db_dbname']);



    if (empty($config)) {

      $message  = "Can not find the CCP6 private config file contents.";





      $result = $this->KHXC->RaiseError($message);



      return $result;

        

    }

     unset($config);
} else {

  $message  = "Can not find the XCS provate config file.";





  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.
} else {

  $message  = "Can not find the XCS public config file.";





  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.





// +--

// | Attempt to load KHXC_DB using an alternate handle.

// +--



$this->KHXC_DBY =& $this->KHXC->load_object(array('app'       => 'khxc',

                                               'class'     => 'KHXC_DB',

                                               'name'      => 'KHXC_DB_3',

                                               'construct' => $dsn));



// +--

// | Handle constructor errors.

// +--



if ($this->KHXC->IsError($this->KHXC_DBY)) {



  $message  = "An error was encountered while attempting to create a new

               database object to connect to the RDBMS specified in the 

               source installation.  The error returned was: ";



  $message .= $this->KHXC_DBY->GetMessage();



  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.



// +--

// | Connect and handle errors.

// +--



$result = $this->KHXC_DBY->connect();



if ($this->KHXC->IsError($result)) {



  $message  = "An error was encountered while attempting to connect to 

               the RDBMS specified in the source installation.  The 

               error returned was: ";



  $message .= $result->GetMessage();



  $result = $this->KHXC->RaiseError($message);



  return $result;



} // End of if statement.







// +--

// | Return.

// +--



  return 1;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_count_rows                                      |

// +------------------------------------------------------------------+



function import_count_rows ($table = '') {



// +--

// | This function counts the rows in a table and returns the count.

// +--



// +--

// | Return an error if we weren't passed a table to load or 

// | table definition information.

// +--



if (empty($table))  {



     $message  = "An error was encountered while attempting to retrieve  

                  data from a table.  No table information was supplied.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Get the data based on the data source.

// +--





 $count = $this->KHXC_DBX->sql_count(array('table' => $table));



 if (($this->KHXC->IsError($count)) || (empty($count))) {$count = 0;}



 return $count;





// +--

// | Return the data.

// +--



return $data;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_load_data                                       |

// +------------------------------------------------------------------+



function import_load_data ($table = '',$offset = 0,$count = 100) {



// +--

// | This function loads data from a table.  It returns a DB-like

// | array.

// +--



// +--

// | Return an error if we weren't passed a table to load or 

// | table definition information.

// +--



if (empty($table)) {



     $message  = "An error was encountered while attempting to retrieve  

                  data from a table.  No table information was supplied.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Get the data based on the data source.

// +--





$data = $this->import_load_rdbmsdata($table,$offset,$count);





// +--

// | Return the data.

// +--



return $data;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_load_csvdata                                    |

// +------------------------------------------------------------------+



function import_load_csvdata ($table = '') {



// +--

// | This function loads data from a CSV file.  It returns a DB-like

// | array.

// +--



global $csvdata;



// +--

// | Return an error if we weren't passed a table to load.

// +--



if (empty($table)) {



     $message  = "An error was encountered while attempting to retrieve  

                  data from a CSV-based table.  No table was supplied.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Return cached data.

// +--



if (!(empty($csvdata[$table]))) {return $csvdata[$table];}



// +--

// | Load the data.

// +--



$file = $this->KHXC->globals('khxc_cgi.import_dirdata') . '/tables/' . $table . '.csv';



$data = $this->KHXC_File->parsecsv(array('filename' => $file));



// +--

// | Handle errors.

// +--



if ($this->KHXC->IsError($data)) {



     $message  = "An error was encountered while attempting to retrieve  

                  data from the {$table} CSV-based table.  The error 

                  returned was: ";



     $message .= $data->GetMessage();



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



if (empty($data['data'])) {return array();}



$csvdata[$table] = $data['data'];



unset($data);



// +--

// | Return the data.

// +--



return $csvdata[$table];



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_load_rdbmsdata                                  |

// +------------------------------------------------------------------+



function import_load_rdbmsdata ($table = '',$offset = 0,$count = 100) {



// +--

// | This function loads data from a RDBMS table.  It returns a DB-like

// | array.

// +--



// +--

// | Return an error if we weren't passed a table to load.

// +--



if (empty($table)) {



     $message  = "An error was encountered while attempting to retrieve  

                  data from a RDBMS-based table.  No table was supplied.";



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Load the data.

// +--



$columns = $this->KHXC_DBX->table_column_string($table);



if ($this->KHXC->IsError($columns)) {



     $message  = "An error was encountered while attempting to retrieve  

                  column information from the {$table} RDBMS-based table. 

                  The error returned was: ";



     $message .= $columns->GetMessage();



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



$sql  = "SELECT {$columns} FROM {$table}";



if ($count == 'ALL') {



     $data = $this->KHXC_DBX->sql_do(array('sql'    => $sql,

                                           'table'  => $table,

                                           'order' => array('id' => 'ASC')));



} else {



     $data = $this->KHXC_DBX->sql_do(array('sql'    => $sql,

                                           'table'  => $table,

                                           'count'  => $count,

                                           'offset' => $offset,

                                           'order' => array('id' => 'ASC')));



} // End of if statement.



// +--

// | Handle errors.

// +--



if ($this->KHXC->IsError($data)) {



     $message  = "An error was encountered while attempting to retrieve  

                  data from the {$table} RDBMS-based table.  The error 

                  returned was: ";



     $message .= $data->GetMessage();



     $result = $this->KHXC->RaiseError($message);



     return $result;



} // End of if statement.



// +--

// | Return the data.

// +--



return $data;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_filter                                          |

// +------------------------------------------------------------------+



function import_filter ($filter = '', $value = '',$settings = array()) {



// +--

// | This function loads settings from the source install.

// +--



$filtered = '';



if ((empty($value)) || (empty($settings))) {return $filtered;}



// +--

// | FILTER: yn2bool

// +--



if ($filter == 'yn2bool') {



     if ($value == 'Y') {$filtered = '1';} else {$filtered = '0';}



// +--

// | FILTER: password

// +--



} elseif ($filter == 'password') {



     $filtered = $this->KHXC_Crypt->decrypt($value,$settings['admin_register_ordernum']);

     $filtered = md5($filtered);



// +--

// | FILTER: strtolower

// +--



} elseif ($filter == 'strtolower') {



     $filtered = strtolower($value);

// +--

// | FILTER: priceround

// +--



} elseif ($filter == 'priceround') {



     $price = round($value, 2);



     if (preg_match('/\./',$price)) {



          list($integer, $decimal) = split('\.', $price, 2);



     } else {



          $integer = $price;

          $decimal = '0';



     } // End of if statement.



     while (strlen($decimal) < 2) {$decimal .= '0';}



     $filtered = $integer . '.' . $decimal;

// +--

// | FILTER: Manage Vat

// +--



} elseif ($filter == 'manage_vat') {



     if ($value == 'N') {$filtered = 'no';} 

	 else if ($value == 'E') {$filtered = 'excleutax';}

	 else if ($value == 'I') {$filtered = 'incleutax';}



} elseif ($filter == 'vat_rebate') {



     if ($value == 'N') {$filtered = 'N';} 

	 else if ($value == 'Y') {$filtered = 'Y';}

	 else if ($value == 'E') {$filtered = 'V';}



} elseif ($filter == 'vat_shipping') {



     if ($value == 'N') {$filtered = 'N';} 

	 else if ($value == 'Y') {$filtered = 'Y';}



} elseif ($filter == 'taxcountry') {



     if ($value == 'N') {$filtered = 'Z';} 

	 else if ($value == 'Y') {$filtered = 'H';}



} elseif ($filter == 'priceround') {



     $filtered = $value;



} elseif ($filter == 'country') {

     if ($value == 'United Kingdom') {$filtered = 'UK - England & Wales';} 

	 else if ($value == 'United Kingdom Main Land') {$filtered = 'UK - England & Wales';}

	 else if ($value == 'Highlands & Islands Scotland') {$filtered = 'UK - Highlands & Islands Scotland';}

	 else if ($value == 'Isles Of Scilly') {$filtered = 'UK - Highlands & Islands Scotland';}

	 else if ($value == 'Isle of Man') {$filtered = 'UK- Isle of Man';}

	 else if ($value == 'Channel Islands') {$filtered = 'UK - Channel Islands';}

	 else if ($value == 'Northern Ireland') {$filtered = 'UK - Northern Ireland';}

	 else { $filtered = $value;}



} // End of if statement.



// +--

// | Return the filtered value.

// +--



return $filtered;



} // End of function.



// +------------------------------------------------------------------+

// | Function: import_changetags                                      |

// +------------------------------------------------------------------+



function import_changetags ($value = '') {



// +--

// | Returns a string stripped of all CGIVAR and CGIGET with 

// | links and image paths fixed.

// +--



if (empty($value)) {return $value;}



// +--

// | Images paths.

// +--



$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/site/','media/<?php print $this->globals(\'khxc.app\'); ?>/html',$value);

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/category/','media/<?php print $this->globals(\'khxc.app\'); ?>/cat',$value);

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_category/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodsm',$value);

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_detail/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodlg',$value);

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_xlarge/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodxl',$value);



// +--

// | URLs specifying reference strings.

// +--



$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)prod\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodshow\',array(\'ref\' => \'\\2\')); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cat\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'catshow\',array(\'ref\' => \'\\2\')); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)form\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'dynform\',array(\'ref\' => \'\\2\')); ?>"',$value);



// +--

// | Special URLs.

// +--



$owner_name = $this->KHXC->globals('khxc_settings.khxc.site_name');



$value = preg_replace('/\(CGIVAR\)common_url_checkout\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'checkout\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url_custacct\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url_affacct\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)design_firm_url\(\/CGIVAR\)/','http://www.kryptronic.com',$value);

$value = preg_replace('/\(CGIVAR\)design_firm_name\(\/CGIVAR\)/','Kryptronic',$value);

$value = preg_replace('/\(CGIVAR\)site_owner_name\(\/CGIVAR\)/',$owner_name,$value);



// +--

// | URLs specifying system pages.

// +--



$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)contact\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'contact\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)maillist\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)splash\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'display\',array(\'ref\' => \'splash\')); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cart\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'viewcart\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)store\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'splash\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)search\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodsearch\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)specials\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodspec\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)bestsell\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodbest\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)new\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodnew\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)track\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)custacct\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)affacct\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);



// +--

// | All other URLs.

// +--



$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'display\',array(\'ref\' => \'\\1\')); ?>"',$value);



// +--

// | Strip font tags.

// +--



$value = preg_replace('/\<FONT(.*?)\>/i','',$value);

$value = preg_replace('/\<\/FONT\>/i','',$value);



// +--

// | Fix some tags we care about.

// +--



$value = preg_replace('/\<B\>/i','<strong>',$value);

$value = preg_replace('/\<\/B\>/i','</strong>',$value);

$value = preg_replace('/\<BR\>/i','<br />',$value);



// +--

// | Strip anything within FORM tags.

// +--



$value = preg_replace('/\<FORM(.*?)\>(.*?)\<\/FORM\>/i','',$value);



// +--

// | Remove any CGIVAR and CGIGET tags that were not stripped.

// +--



$value = preg_replace('/\(CGIVAR\)(.*?)\(\/CGIVAR\)/','',$value);

$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)" PARAMS="(.*?)"\)/','',$value);

$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)"\)/','',$value);



// +--

// | Return the value.

// +--



return $value;



} // End of if statement.



// +------------------------------------------------------------------+

// | Function: import_price_round                                     |

// +------------------------------------------------------------------+



function import_price_round ($price = '0.00') {



// +--

// | Return a rounded price.

// +--



$price = round($price, 2);



if (preg_match('/\./',$price)) {



     list($integer, $decimal) = split('\.', $price, 2);



} else {



     $integer = $price;

     $decimal = '0';



} // End of if statement.



while (strlen($decimal) < 2) {$decimal .= '0';}



return $integer . '.' . $decimal;



} // End of if statement.



// +------------------------------------------------------------------+

// | Function: import_return_skinphp                                  |

// +------------------------------------------------------------------+



function import_return_skinphp () {



// +--

// | Return the skin.php template.

// +--



return <<<ENDOFTEXT

     <?php /* PHP FUNCTION */

           /* REQUIRED: Skin startup */

           \$skinfunc =& \$this->include_skinfunc('KHXC_SkinFunc');

           extract(\$skinfunc->startup()); ?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">



<html>



<head>



<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />



<meta name="keywords" content="<?php print \$metakeywords; ?>" />



<meta name="description" content="<?php print \$metadesc; ?>" />



<meta name="robots" content="index,follow" />



<base href="<?php print \$disp_baseurl; ?>" />



     <?php /* PHP FUNCTION */

           /* REQUIRED: Prints lightbox code */

           \$skinfunc->lightbox(); ?>



<link rel="stylesheet" type="text/css" media="all" href="skins/CCP5XIMPORT/css/all.css" />



<script type="text/javascript" src="skins/CCP5XIMPORT/scripts/scripts.js"></script>



<title><?php print \$metatitle; ?></title>



</head>



     <?php /* PHP FUNCTION */

           /* REQUIRED: Prints the body tag */

           \$skinfunc->bodytag(); ?>



<div id="skin_wrapper">



<khxc:content />



</div>



<div id="skin_footer">



     <?php /* PHP FUNCTION */

           /* Print the application owner's address and phone */

           /* numbers here.                                   */

           \$skinfunc->printaddphone(); ?>



<p>&copy; <?php print \$disp_year . ' ' . \$site_name; ?>. All rights reserved worldwide.</p>



<p>

<a href="http://www.kryptronic.com/" title="Kryptronic"><img src="media/khxc/powered_khxc.png" alt="KHXC Powered" width="79" height="24" /></a>

&nbsp;

<img src="media/khxc/valid-xhtml10.png" alt="Valid XHTML" width="79" height="24" />

&nbsp;

<img src="media/khxc/valid-css.png" alt="Valid CSS" width="79" height="24" /></p>



</div>



     <?php /* PHP FUNCTION */

           /* REQUIRED: Run the debug and closure function. */

           \$skinfunc->debug(); ?>



</body>



</html>



ENDOFTEXT;



} // End of if statement.



// +------------------------------------------------------------------+

// | Function: import_return_allcss                                   |

// +------------------------------------------------------------------+



function import_return_allcss () {



// +--

// | Return the all.css template.

// +--



return <<<ENDOFTEXT



body {

     color: #000000;

     background-color: #FFFFFF;

     font-family: Verdana, Tahoma, Arial, sans-serif;

     font-size: 11px;

     font-weight: normal;

     text-align: left;

     margin: 10px;

     }



a {

     color: #0000FF;

     background-color: inherit;

     font-weight: bold;

     text-decoration: none;

     cursor: pointer;

     }



p {

     color: inherit;

     background-color: inherit;

     margin: 5px 0px 7px 0px;

     }



sup {

     color: inherit;

     background-color: inherit;

     display: inline;

     padding: 0px;

     vertical-align: super;

     font-size: 8px;

     }



a:hover {

     color: inherit;

     background-color: inherit;

     text-decoration: underline;

     }



fieldset {

     color: inherit;

     background-color: inherit;

     border: none;

     padding: 5px 0px 5px 0px;

     }



fieldset p {

     color: inherit;

     background-color: inherit;

     display: block;

     font-size: 11px;

     margin: 5px 5px 5px 2px;

     }



form {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 5px 0px;

     }



img {

     color: inherit;

     background-color: inherit;

     border: none;

     }



li {

     color: inherit;

     background-color: inherit;

     padding-bottom: 5px;

     }



.center {

     color: inherit;

     background-color: inherit;

     text-align: center;

     }



.inlinecenter {

     color: inherit;

     background-color: inherit;

     text-align: center;

     }



p.inline {

     color: inherit;

     background-color: inherit;

     display: inline;

     padding: 0px;

     }



.strong {

     color: inherit;

     background-color: inherit;

     font-weight: bold;

     }



.big {

     font-weight: bold;

     font-size: 14px;

     }



.hidden {

     color: inherit;

     background-color: inherit;

     display: none;

     }



a.unfancy {

     color: inherit;

     background-color: inherit;

     text-decoration: underline;

     font-weight: normal;

     }



a.unfancy:hover {

     color: inherit;

     background-color: inherit;

     text-decoration: underline;

     }



#skin_wrapper {

     color: inherit;

     background-color: inherit;

     width: 90%;

     padding: 5px;

     margin: auto;

     }



#skin_content {

     color: inherit;

     background-color: inherit;

     margin: auto;

     }



#skin_footer {

     text-align: center;

     color: inherit;

     background-color: inherit;

     width: 99%;

     padding: 5px;

     margin-top: 10px;

     }



#skin_pgtitle {

     color: #333333;

     background-color: inherit;

     padding: 3px 5px 3px 5px;

     margin: 0px 0px 10px 0px;

     border-bottom: 1px solid #CCCCCC;

     font-weight: bold;

     font-size: 14px;

     }



.skin_fenavh {

     color: #333333;

     background-color: inherit;

     padding: 3px 5px 3px 5px;

     margin: 0px 0px 0px 0px;

     border-bottom: 1px solid #CCCCCC;

     font-weight: bold;

     }



.skin_fenav ul {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px 0px 10px 0px;

     list-style: none;

     }



.skin_fenav ul li {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px;

     border-bottom: 1px solid #CDCDCD;

     list-style: none;

     }



.skin_fenav ul li a {

     color: #333333;

     background-color: inherit;

     font-weight: normal;

     display: block;

     text-decoration: none;

     padding: 3px 5px 3px 5px;

     }



.skin_fenav ul li a:hover {

     color: #333333;

     background-color: #CCCCCC;

     text-decoration: none;

     }



.skin_button {

     color: #333333;

     background-color: #CCCCCC;

     padding: 0px;

     border: 1px solid #36586F;

     margin: 0px 0px 10px 3px;

     display: block;

     float: right;

     }



.skin_button a {

     color: #333333;

     background-color: #CCCCCC;

     font-weight: normal;

     display: block;

     padding: 2px 7px 2px 7px;

     }



.skin_button a:hover {

     color: #333333;

     background-color: #EFEFEF;

     text-decoration: none;

     }



.skin_fenavmini {

     color: inherit;

     background-color: inherit;

     padding: 5px;

     margin: 0px 0px 10px 0px;

     border-left: 1px solid #36586F;

     border-right: 1px solid #36586F;

     border-bottom: 1px solid #36586F;

     }



#khxc_debug {

     color: #333333;

     background-color: #FFFFFF;

     border: 1px solid #000000;

     padding: 10px;

     overflow: hidden;

     margin-top: 10px;

     }



#khxc_printable {

     color: inherit;

     background-color: #FFFFFF;

     border: 1px solid #000000;

     width: 800px;

     padding: 10px;

     margin: auto;

     }



.khxc_error {

     color: #FF0000;

     background-color: inherit;

     font-weight: bold;

     }



.khxc_confirm {

     color: #339933;

     background-color: inherit;

     font-weight: bold;

     }



.khxc_imgfloatrt {

     color: inherit;

     background-color: inherit;

     float: right;

     margin-bottom: 10px;

     margin-left: 10px;

     display: inline;

     }



.khxc_inline {

     color: inherit;

     background-color: inherit;

     display: inline;

     }



.khxc_preboxed {

     color: inherit;

     background-color: #F7F7F7;

     margin: 5px 0px 0px 0px;

     padding: 5px;

     border: 1px solid #000000;

     font-family: Fixed, monospace;

     overflow: hidden;

     }



.khxc_formfieldradcb {

     color: inherit;

     background-color: inherit;

     }



.khxc_formfield {

     color: inherit;

     background-color: #FFFFFF;

     border: 1px solid #000000;

     font-size: 11px;

     margin: 5px 5px 0px 2px;

     }



.khxc_formfield:hover {

     color: inherit;

     background-color: #DEDEDE;

     }



.khxc_formfieldp {

     color: inherit;

     background-color: inherit;

     display: block;

     padding: 0px;

     margin: 0px;

     }



.khxc_formfieldpnfs {

     color: inherit;

     background-color: inherit;

     display: block;

     padding: 0px 5px 0px 5px;

     margin: 0px 0px 5px 0px;

     }



.khxc_formfielda {

     color: #0000FF;

     background-color: inherit;

     display: block;

     padding: 0px 5px 0px 5px;

     margin: 0px 0px 2px 0px;

     font-weight: normal;

     }



.khxc_formbutton {

     color: #333333;

     background-color: #CCCCCC;

     border: 1px solid #000000;

     padding: 1px;

     margin: 0px 0px 5px 0px;

     font-size: 11px;

     width: 130px;

     }



.khxc_formbutton:hover {

     color: #333333;

     background-color: #EFEFEF;

     }



.khxc_quickbutton {

     color: #333333;

     background-color: #CCCCCC;

     border: 1px solid #000000;

     padding: 1px;

     margin: 0px;

     font-size: 11px;

     width: 130px;

     }



.khxc_quickbutton:hover {

     color: #333333;

     background-color: #EFEFEF;

     }



.khxc_quickform {

     color: inherit;

     background-color: inherit;

     margin: 5px 0px 0px 0px;

     }



.khxc_quickfield {

     color: inherit;

     background-color: #DEDEDE;

     border: 1px solid #000000;

     font-size: 11px;

     margin: 1px 0px 0px 0px;

     }



.khxc_quickfield:hover {

     color: inherit;

     background-color: #FFFFFF;

     }



.khxc_formfieldradcb_rnc {

     color: inherit;

     background-color: #FFA4A4;

     }



.khxc_formfield_rnc {

     color: inherit;

     background-color: #FFA4A4;

     border: 1px solid #000000;

     font-size: 11px;

     margin: 5px 5px 0px 2px;

     }



.khxc_formfield_rnc:hover {

     color: inherit;

     background-color: #DEDEDE;

     }



.khxc_formsecthead {

     color: #333333;

     background-color: inherit;

     padding: 2px 5px 2px 5px;

     margin: 0px;

     font-weight: bold;

     font-size: 14px;

     border-bottom: 1px solid #CCCCCC;

     }



table.khxc_formtblone {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 5px 0px;

     border-spacing: 3px;

     width: 100%;

     }



table.khxc_formtbltwo {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 5px 0px;

     border-spacing: 3px;

     width: 100%;

     }



td.khxc_formtbltwo {

     color: inherit;

     background-color: #F7F7F7;

     padding: 4px 2px 2px 2px;

     width: 50%;

     border-top: 1px solid #BCBCBC;

     border-left: 1px solid #BCBCBC;

     vertical-align: top;

     }



td.khxc_formtbltwospan {

     color: inherit;

     background-color: #F7F7F7;

     padding: 4px 2px 2px 2px;

     width: 100%;

     border-top: 1px solid #BCBCBC;

     border-left: 1px solid #BCBCBC;

     vertical-align: top;

     }



td.khxc_formtblone {

     color: inherit;

     background-color: #F7F7F7;

     padding: 4px 2px 2px 2px;

     width: 50%;

     border-top: 1px solid #BCBCBC;

     border-left: 1px solid #BCBCBC;

     vertical-align: top;

     }



table.khxc_sorttable {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 0px 0px;

     border-spacing: 3px;

     width: 100%;

     }



th.khxc_sorttable {

     color: inherit;

     background-color: inherit;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



td.khxc_sorttable {

     color: inherit;

     background-color: inherit;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



.khxc_regtablehead {

     color: #333333;

     background-color: inherit;

     padding: 2px 5px 2px 5px;

     margin: 0px;

     border-bottom: 1px solid #CCCCCC;

     font-weight: bold;

     font-size: 14px;

     clear: both;

     }



table.khxc_regtable {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 5px 0px;

     border-spacing: 3px;

     width: 100%;

     }



tr.khxc_regtable {

     color: inherit;

     background-color: inherit;

     padding: 5px;

     border: 1px solid #000000;

     }



th.khxc_regtable {

     color: inherit;

     background-color: inherit;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



td.khxc_regtable {

     color: inherit;

     background-color: #F7F7F7;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



.khxc_regtable p {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px 0px 5px 0px;

     }



table.khxc_ghost {

     color: inherit;

     background-color: inherit;

     margin: 0px;

     padding: 0px;

     border-spacing: 3px;

     width: 100%;

     }



td.khxc_ghost {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px;

     vertical-align: top;

     }



.khxc_ghost form {

     color: inherit;

     background-color: inherit;

     display: inline;

}



td.khxc_ghost img {

     color: inherit;

     background-color: inherit;

     margin-right: 10px;

     margin-bottom: 10px;

     }



td.khxc_ghost p {

     margin: 0px 0px 6px 0px;

}



p.khxc_uktablesp {

     color: inherit;

     background-color: inherit;

     margin: 0px;

     font-size: 1px;

     }



.khxc_storehead {

     color: #333333;

     background-color: inherit;

     padding: 2px 5px 2px 5px;

     margin: 10px 0px 2px 0px;

     border-bottom: 1px solid #CCCCCC;

     font-weight: bold;

     font-size: 14px;

     clear: both;

     }



.khxc_storelink {

     color: inherit;

     background-color: #F7F7F7;

     padding: 0px 5px 0px 5px;

     margin: 5px 0px 10px 0px;

     border: 1px solid #CCCCCC;

     }



.khxc_storelink a {

     color: #0000FF;

     background-color: inherit;

     font-weight: normal;

     }



.khxc_storelink p {

     color: inherit;

     background-color: inherit;

     margin: 4px 0px 4px 0px;

     }



table.khxc_cptbl_cat {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 10px 0px;

     border-spacing: 3px;

     width: 100%;

     }



tr.khxc_cptbl_cat {

     color: inherit;

     background-color: inherit;

     }



td.khxc_cptbl_cat {

     color: inherit;

     background-color: inherit;

     padding: 4px 4px 2px 4px;

     border: 1px solid #CCCCCC;

     vertical-align: top;

     }



td.khxc_cptbl_cat_blank {

     color: inherit;

     background-color: inherit;

     display: none;

     }



table.khxc_cptbl_prod {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 10px 0px;

     border-spacing: 3px;

     width: 100%;

     }



tr.khxc_cptbl_prod {

     color: inherit;

     background-color: inherit;

     }



td.khxc_cptbl_prod {

     color: inherit;

     background-color: inherit;

     padding: 4px 4px 2px 4px;

     border: 1px solid #CCCCCC;

     vertical-align: top;

     }



td.khxc_cptbl_prod_blank {

     color: inherit;

     background-color: inherit;

     display: none;

     }



table.khxc_cptbl_det {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 10px 0px;

     border-spacing: 3px;

     width: 100%;

     }



tr.khxc_cptbl_det {

     color: inherit;

     background-color: inherit;

     }



td.khxc_cptbl_det {

     color: inherit;

     background-color: inherit;

     padding: 4px 4px 2px 4px;

     border: 1px solid #CCCCCC;

     vertical-align: top;

     }



td.khxc_cptbl_det_blank {

     color: inherit;

     background-color: inherit;

     display: none;

     }



.khxc_pricediv {

     color: inherit;

     background-color: inherit;

     margin: 2px 0px 2px 0px;

     }



.khxc_price {

     color: inherit;

     background-color: inherit;

     display: inline;

     }



.khxc_pricex {

     color: #FF0000;

     background-color: inherit;

     display: inline;

     text-decoration: line-through;

     }



.khxc_cartbutton {

     color: #333333;

     background-color: #CCCCCC;

     border: 1px solid #000000;

     padding: 1px;

     font-size: 11px;

     font-weight: normal;

     text-align: center;

     display: block;

     margin: 0px 0px 5px 0px;

     width: 125px;

     }



.khxc_cartbutton:hover {

     color: #333333;

     background-color: #EFEFEF;

     text-decoration: none;

     cursor: default;

     }



table.khxc_ghost {

     color: inherit;

     background-color: inherit;

     margin: 0px;

     padding: 0px;

     border-spacing: 3px;

     width: 100%;

     }



td.khxc_ghost {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px;

     vertical-align: top;

     }



.khxc_ghost form {

     color: inherit;

     background-color: inherit;

     display: inline;

}



td.khxc_ghost img {

     color: inherit;

     background-color: inherit;

     margin-right: 10px;

     margin-bottom: 10px;

     }



td.khxc_ghost p {

     margin: 0px 0px 6px 0px;

}



table.khxc_ordsumm {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 5px 0px;

     border-spacing: 3px;

     width: 100%;

     }



.khxc_ordsumm a {

     color: #0000FF;

     background-color: inherit;

     font-weight: bold;

     text-decoration: none;

     }



tr.khxc_ordsumm {

     color: inherit;

     background-color: inherit;

     padding: 5px;

     border: 1px solid #000000;

     }



th.khxc_ordsumm {

     color: inherit;

     background-color: inherit;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



td.khxc_ordsumm {

     color: inherit;

     background-color: #F7F7F7;

     padding: 4px 3px 4px 3px;

     border-top: 1px solid #CDCDCD;

     border-left: 1px solid #CDCDCD;

     vertical-align: top;

     }



.khxc_ordsumm p {

     color: inherit;

     background-color: inherit;

     padding: 0px;

     margin: 0px 0px 5px 0px;

     }



.khxc_ordsumm a {

     color: #3E6B8A;

     background-color: inherit;

     }



.khxc_ordsumm a:hover {

     color: inherit;

     background-color: inherit;

     text-decoration: underline;

     }



.khxc_ordsummhead {

     color: #333333;

     background-color: inherit;

     padding: 2px 5px 2px 5px;

     margin: 0px;

     border-bottom: 1px solid #CCCCCC;

     font-weight: bold;

     font-size: 14px;

     clear: both;

     }



.khxc_ordsummcenter {

     color: inherit;

     background-color: inherit;

     text-align: center;

     padding: 0px;

     margin: 0px 0px 10px 0px;

     border: 1px solid #000000;

     }



.khxc_ordsummbig {

     color: inherit;

     background-color: inherit;

     font-weight: bold;

     font-size: 16px;

     }



.khxc_ordsummlink {

     color: inherit;

     background-color: #F7F7F7;

     padding: 0px 5px 0px 5px;

     margin: 10px 0px 10px 0px;

     border: 1px solid #CCCCCC;

     }



.khxc_ordsummlink a {

     color: #0000FF;

     background-color: inherit;

     font-weight: normal;

     }



h1.khxc_secthead {

     color: inherit;

     background-color: inherit;

     font-weight: bold;

     font-size: 11px;

     text-decoration: underline;

     }



.khxc_clearboth {

     color: inherit;

     background-color: inherit;

     clear: both;

     }



.khxc_outstock {

     color: #FF0000;

     background-color: inherit;

     }



a.khxc_hrefbutton {

     color: #333333;

     background-color: #CCCCCC;

     border: 1px solid #000000;

     padding: 2px 5px 2px 5px;

     font-size: 11px;

     font-weight: normal;

     text-align: center;

     display: block;

     }



a.khxc_hrefbutton:hover {

     color: #333333;

     background-color: #EFEFEF;

     text-decoration: none;

     cursor: default;

     }



.khxc_outline {

     color: inherit;

     background-color: #F7F7F7;

     border: 1px solid #CCCCCC;

     padding: 5px;

     margin-top: 5px;

     }



.khxc_outlinetrans {

     color: inherit;

     background-color: inherit;

     border: 1px solid #CCCCCC;

     }



.khxc_outline p {

     color: inherit;

     background-color: inherit;

     margin: 0px 0px 3px 0px;

}



ENDOFTEXT;



} // End of if statement.



// +------------------------------------------------------------------+

// | End of Class                                               [KHXC]|

// +------------------------------------------------------------------+



} // End of class.



// +------------------------------------------------------------------+

// | End Of File                                                [KHXC]|

// +------------------------------------------------------------------+



?>